// Code generated by GoVPP's binapi-generator. DO NOT EDIT.

// Package ipsec contains generated bindings for API file ipsec.api.
//
// Contents:
// -  2 structs
// - 60 messages
package ipsec

import (
	interface_types "github.com/projectcalico/vpp-dataplane/v3/vpplink/generated/bindings/interface_types"
	ip_types "github.com/projectcalico/vpp-dataplane/v3/vpplink/generated/bindings/ip_types"
	ipsec_types "github.com/projectcalico/vpp-dataplane/v3/vpplink/generated/bindings/ipsec_types"
	tunnel_types "github.com/projectcalico/vpp-dataplane/v3/vpplink/generated/bindings/tunnel_types"
	api "go.fd.io/govpp/api"
	codec "go.fd.io/govpp/codec"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the GoVPP api package it is being compiled against.
// A compilation error at this line likely means your copy of the
// GoVPP api package needs to be updated.
const _ = api.GoVppAPIPackageIsVersion2

const (
	APIFile    = "ipsec"
	APIVersion = "5.0.2"
	VersionCrc = 0x8d9c3489
)

// IpsecItf defines type 'ipsec_itf'.
type IpsecItf struct {
	UserInstance uint32                         `binapi:"u32,name=user_instance,default=4294967295" json:"user_instance,omitempty"`
	Mode         tunnel_types.TunnelMode        `binapi:"tunnel_mode,name=mode" json:"mode,omitempty"`
	SwIfIndex    interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
}

// IpsecTunnelProtect defines type 'ipsec_tunnel_protect'.
type IpsecTunnelProtect struct {
	SwIfIndex interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
	Nh        ip_types.Address               `binapi:"address,name=nh" json:"nh,omitempty"`
	SaOut     uint32                         `binapi:"u32,name=sa_out" json:"sa_out,omitempty"`
	NSaIn     uint8                          `binapi:"u8,name=n_sa_in" json:"-"`
	SaIn      []uint32                       `binapi:"u32[n_sa_in],name=sa_in" json:"sa_in,omitempty"`
}

// IPsec backend details
//   - name - name of the backend
//   - protocol - IPsec protocol (value from ipsec_protocol_t)
//   - index - backend index
//   - active - set to 1 if the backend is active, otherwise 0
//
// IpsecBackendDetails defines message 'ipsec_backend_details'.
type IpsecBackendDetails struct {
	Name     string                 `binapi:"string[128],name=name" json:"name,omitempty"`
	Protocol ipsec_types.IpsecProto `binapi:"ipsec_proto,name=protocol" json:"protocol,omitempty"`
	Index    uint8                  `binapi:"u8,name=index" json:"index,omitempty"`
	Active   bool                   `binapi:"bool,name=active" json:"active,omitempty"`
}

func (m *IpsecBackendDetails) Reset()               { *m = IpsecBackendDetails{} }
func (*IpsecBackendDetails) GetMessageName() string { return "ipsec_backend_details" }
func (*IpsecBackendDetails) GetCrcString() string   { return "ee601c29" }
func (*IpsecBackendDetails) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecBackendDetails) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 128 // m.Name
	size += 4   // m.Protocol
	size += 1   // m.Index
	size += 1   // m.Active
	return size
}
func (m *IpsecBackendDetails) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeString(m.Name, 128)
	buf.EncodeUint32(uint32(m.Protocol))
	buf.EncodeUint8(m.Index)
	buf.EncodeBool(m.Active)
	return buf.Bytes(), nil
}
func (m *IpsecBackendDetails) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Name = buf.DecodeString(128)
	m.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Index = buf.DecodeUint8()
	m.Active = buf.DecodeBool()
	return nil
}

// Dump IPsec backends
// IpsecBackendDump defines message 'ipsec_backend_dump'.
type IpsecBackendDump struct{}

func (m *IpsecBackendDump) Reset()               { *m = IpsecBackendDump{} }
func (*IpsecBackendDump) GetMessageName() string { return "ipsec_backend_dump" }
func (*IpsecBackendDump) GetCrcString() string   { return "51077d14" }
func (*IpsecBackendDump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecBackendDump) Size() (size int) {
	if m == nil {
		return 0
	}
	return size
}
func (m *IpsecBackendDump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	return buf.Bytes(), nil
}
func (m *IpsecBackendDump) Unmarshal(b []byte) error {
	return nil
}

// IPsec: Add/delete SPD from interface
//   - is_add - add security mode if non-zero, else delete
//   - sw_if_index - index of the interface
//   - spd_id - SPD instance id to use for lookups
//
// IpsecInterfaceAddDelSpd defines message 'ipsec_interface_add_del_spd'.
type IpsecInterfaceAddDelSpd struct {
	IsAdd     bool                           `binapi:"bool,name=is_add" json:"is_add,omitempty"`
	SwIfIndex interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
	SpdID     uint32                         `binapi:"u32,name=spd_id" json:"spd_id,omitempty"`
}

func (m *IpsecInterfaceAddDelSpd) Reset()               { *m = IpsecInterfaceAddDelSpd{} }
func (*IpsecInterfaceAddDelSpd) GetMessageName() string { return "ipsec_interface_add_del_spd" }
func (*IpsecInterfaceAddDelSpd) GetCrcString() string   { return "80f80cbb" }
func (*IpsecInterfaceAddDelSpd) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecInterfaceAddDelSpd) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 1 // m.IsAdd
	size += 4 // m.SwIfIndex
	size += 4 // m.SpdID
	return size
}
func (m *IpsecInterfaceAddDelSpd) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeBool(m.IsAdd)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	buf.EncodeUint32(m.SpdID)
	return buf.Bytes(), nil
}
func (m *IpsecInterfaceAddDelSpd) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.IsAdd = buf.DecodeBool()
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.SpdID = buf.DecodeUint32()
	return nil
}

// IpsecInterfaceAddDelSpdReply defines message 'ipsec_interface_add_del_spd_reply'.
type IpsecInterfaceAddDelSpdReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecInterfaceAddDelSpdReply) Reset() { *m = IpsecInterfaceAddDelSpdReply{} }
func (*IpsecInterfaceAddDelSpdReply) GetMessageName() string {
	return "ipsec_interface_add_del_spd_reply"
}
func (*IpsecInterfaceAddDelSpdReply) GetCrcString() string { return "e8d4e804" }
func (*IpsecInterfaceAddDelSpdReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecInterfaceAddDelSpdReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecInterfaceAddDelSpdReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecInterfaceAddDelSpdReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// Create an IPSec interface
// IpsecItfCreate defines message 'ipsec_itf_create'.
type IpsecItfCreate struct {
	Itf IpsecItf `binapi:"ipsec_itf,name=itf" json:"itf,omitempty"`
}

func (m *IpsecItfCreate) Reset()               { *m = IpsecItfCreate{} }
func (*IpsecItfCreate) GetMessageName() string { return "ipsec_itf_create" }
func (*IpsecItfCreate) GetCrcString() string   { return "6f50b3bc" }
func (*IpsecItfCreate) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecItfCreate) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Itf.UserInstance
	size += 1 // m.Itf.Mode
	size += 4 // m.Itf.SwIfIndex
	return size
}
func (m *IpsecItfCreate) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Itf.UserInstance)
	buf.EncodeUint8(uint8(m.Itf.Mode))
	buf.EncodeUint32(uint32(m.Itf.SwIfIndex))
	return buf.Bytes(), nil
}
func (m *IpsecItfCreate) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Itf.UserInstance = buf.DecodeUint32()
	m.Itf.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Itf.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	return nil
}

// Add IPsec interface interface response
//   - retval - return status
//   - sw_if_index - sw_if_index of new interface (for successful add)
//
// IpsecItfCreateReply defines message 'ipsec_itf_create_reply'.
type IpsecItfCreateReply struct {
	Retval    int32                          `binapi:"i32,name=retval" json:"retval,omitempty"`
	SwIfIndex interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
}

func (m *IpsecItfCreateReply) Reset()               { *m = IpsecItfCreateReply{} }
func (*IpsecItfCreateReply) GetMessageName() string { return "ipsec_itf_create_reply" }
func (*IpsecItfCreateReply) GetCrcString() string   { return "5383d31f" }
func (*IpsecItfCreateReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecItfCreateReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	size += 4 // m.SwIfIndex
	return size
}
func (m *IpsecItfCreateReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	return buf.Bytes(), nil
}
func (m *IpsecItfCreateReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	return nil
}

// IpsecItfDelete defines message 'ipsec_itf_delete'.
type IpsecItfDelete struct {
	SwIfIndex interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
}

func (m *IpsecItfDelete) Reset()               { *m = IpsecItfDelete{} }
func (*IpsecItfDelete) GetMessageName() string { return "ipsec_itf_delete" }
func (*IpsecItfDelete) GetCrcString() string   { return "f9e6675e" }
func (*IpsecItfDelete) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecItfDelete) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SwIfIndex
	return size
}
func (m *IpsecItfDelete) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	return buf.Bytes(), nil
}
func (m *IpsecItfDelete) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	return nil
}

// IpsecItfDeleteReply defines message 'ipsec_itf_delete_reply'.
type IpsecItfDeleteReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecItfDeleteReply) Reset()               { *m = IpsecItfDeleteReply{} }
func (*IpsecItfDeleteReply) GetMessageName() string { return "ipsec_itf_delete_reply" }
func (*IpsecItfDeleteReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecItfDeleteReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecItfDeleteReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecItfDeleteReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecItfDeleteReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// IpsecItfDetails defines message 'ipsec_itf_details'.
type IpsecItfDetails struct {
	Itf IpsecItf `binapi:"ipsec_itf,name=itf" json:"itf,omitempty"`
}

func (m *IpsecItfDetails) Reset()               { *m = IpsecItfDetails{} }
func (*IpsecItfDetails) GetMessageName() string { return "ipsec_itf_details" }
func (*IpsecItfDetails) GetCrcString() string   { return "548a73b8" }
func (*IpsecItfDetails) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecItfDetails) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Itf.UserInstance
	size += 1 // m.Itf.Mode
	size += 4 // m.Itf.SwIfIndex
	return size
}
func (m *IpsecItfDetails) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Itf.UserInstance)
	buf.EncodeUint8(uint8(m.Itf.Mode))
	buf.EncodeUint32(uint32(m.Itf.SwIfIndex))
	return buf.Bytes(), nil
}
func (m *IpsecItfDetails) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Itf.UserInstance = buf.DecodeUint32()
	m.Itf.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Itf.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	return nil
}

// IpsecItfDump defines message 'ipsec_itf_dump'.
type IpsecItfDump struct {
	SwIfIndex interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
}

func (m *IpsecItfDump) Reset()               { *m = IpsecItfDump{} }
func (*IpsecItfDump) GetMessageName() string { return "ipsec_itf_dump" }
func (*IpsecItfDump) GetCrcString() string   { return "f9e6675e" }
func (*IpsecItfDump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecItfDump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SwIfIndex
	return size
}
func (m *IpsecItfDump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	return buf.Bytes(), nil
}
func (m *IpsecItfDump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	return nil
}

// IPsec security association database response
//   - entry - The SA details
//   - sw_if_index - sw_if_index of tunnel interface, policy-based SAs = ~0
//   - salt - 4 byte salt
//   - seq - current sequence number for outbound
//   - seq_hi - high 32 bits of ESN for outbound
//   - last_seq - highest sequence number received inbound
//   - last_seq_hi - high 32 bits of highest ESN received inbound
//   - replay_window - bit map of seq nums received relative to last_seq if using anti-replay
//   - stat_index - index for the SA in the stats segment @ /net/ipsec/sa
//
// IpsecSaDetails defines message 'ipsec_sa_details'.
// Deprecated: the message will be removed in the future versions
type IpsecSaDetails struct {
	Entry          ipsec_types.IpsecSadEntry      `binapi:"ipsec_sad_entry,name=entry" json:"entry,omitempty"`
	SwIfIndex      interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
	Salt           uint32                         `binapi:"u32,name=salt" json:"salt,omitempty"`
	SeqOutbound    uint64                         `binapi:"u64,name=seq_outbound" json:"seq_outbound,omitempty"`
	LastSeqInbound uint64                         `binapi:"u64,name=last_seq_inbound" json:"last_seq_inbound,omitempty"`
	ReplayWindow   uint64                         `binapi:"u64,name=replay_window" json:"replay_window,omitempty"`
	StatIndex      uint32                         `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSaDetails) Reset()               { *m = IpsecSaDetails{} }
func (*IpsecSaDetails) GetMessageName() string { return "ipsec_sa_details" }
func (*IpsecSaDetails) GetCrcString() string   { return "345d14a7" }
func (*IpsecSaDetails) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSaDetails) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 1       // m.Entry.TunnelSrc.Af
	size += 1 * 16  // m.Entry.TunnelSrc.Un
	size += 1       // m.Entry.TunnelDst.Af
	size += 1 * 16  // m.Entry.TunnelDst.Un
	size += 4       // m.Entry.TxTableID
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	size += 4       // m.SwIfIndex
	size += 4       // m.Salt
	size += 8       // m.SeqOutbound
	size += 8       // m.LastSeqInbound
	size += 8       // m.ReplayWindow
	size += 4       // m.StatIndex
	return size
}
func (m *IpsecSaDetails) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint8(uint8(m.Entry.TunnelSrc.Af))
	buf.EncodeBytes(m.Entry.TunnelSrc.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.TunnelDst.Af))
	buf.EncodeBytes(m.Entry.TunnelDst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(m.Entry.TxTableID)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	buf.EncodeUint32(m.Salt)
	buf.EncodeUint64(m.SeqOutbound)
	buf.EncodeUint64(m.LastSeqInbound)
	buf.EncodeUint64(m.ReplayWindow)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSaDetails) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.TunnelSrc.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.TunnelSrc.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.TunnelDst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.TunnelDst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.TxTableID = buf.DecodeUint32()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Salt = buf.DecodeUint32()
	m.SeqOutbound = buf.DecodeUint64()
	m.LastSeqInbound = buf.DecodeUint64()
	m.ReplayWindow = buf.DecodeUint64()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// Dump IPsec security association
//   - sa_id - optional ID of an SA to dump, if ~0 dump all SAs in SAD
//
// IpsecSaDump defines message 'ipsec_sa_dump'.
// Deprecated: the message will be removed in the future versions
type IpsecSaDump struct {
	SaID uint32 `binapi:"u32,name=sa_id" json:"sa_id,omitempty"`
}

func (m *IpsecSaDump) Reset()               { *m = IpsecSaDump{} }
func (*IpsecSaDump) GetMessageName() string { return "ipsec_sa_dump" }
func (*IpsecSaDump) GetCrcString() string   { return "2076c2f4" }
func (*IpsecSaDump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSaDump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SaID
	return size
}
func (m *IpsecSaDump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SaID)
	return buf.Bytes(), nil
}
func (m *IpsecSaDump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SaID = buf.DecodeUint32()
	return nil
}

// IpsecSaV2Details defines message 'ipsec_sa_v2_details'.
// Deprecated: the message will be removed in the future versions
type IpsecSaV2Details struct {
	Entry          ipsec_types.IpsecSadEntryV2    `binapi:"ipsec_sad_entry_v2,name=entry" json:"entry,omitempty"`
	SwIfIndex      interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
	Salt           uint32                         `binapi:"u32,name=salt" json:"salt,omitempty"`
	SeqOutbound    uint64                         `binapi:"u64,name=seq_outbound" json:"seq_outbound,omitempty"`
	LastSeqInbound uint64                         `binapi:"u64,name=last_seq_inbound" json:"last_seq_inbound,omitempty"`
	ReplayWindow   uint64                         `binapi:"u64,name=replay_window" json:"replay_window,omitempty"`
	StatIndex      uint32                         `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSaV2Details) Reset()               { *m = IpsecSaV2Details{} }
func (*IpsecSaV2Details) GetMessageName() string { return "ipsec_sa_v2_details" }
func (*IpsecSaV2Details) GetCrcString() string   { return "e2130051" }
func (*IpsecSaV2Details) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSaV2Details) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 1       // m.Entry.TunnelSrc.Af
	size += 1 * 16  // m.Entry.TunnelSrc.Un
	size += 1       // m.Entry.TunnelDst.Af
	size += 1 * 16  // m.Entry.TunnelDst.Un
	size += 1       // m.Entry.TunnelFlags
	size += 1       // m.Entry.Dscp
	size += 4       // m.Entry.TxTableID
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	size += 4       // m.SwIfIndex
	size += 4       // m.Salt
	size += 8       // m.SeqOutbound
	size += 8       // m.LastSeqInbound
	size += 8       // m.ReplayWindow
	size += 4       // m.StatIndex
	return size
}
func (m *IpsecSaV2Details) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint8(uint8(m.Entry.TunnelSrc.Af))
	buf.EncodeBytes(m.Entry.TunnelSrc.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.TunnelDst.Af))
	buf.EncodeBytes(m.Entry.TunnelDst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.TunnelFlags))
	buf.EncodeUint8(uint8(m.Entry.Dscp))
	buf.EncodeUint32(m.Entry.TxTableID)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	buf.EncodeUint32(m.Salt)
	buf.EncodeUint64(m.SeqOutbound)
	buf.EncodeUint64(m.LastSeqInbound)
	buf.EncodeUint64(m.ReplayWindow)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSaV2Details) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.TunnelSrc.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.TunnelSrc.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.TunnelDst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.TunnelDst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.TunnelFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Entry.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Entry.TxTableID = buf.DecodeUint32()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Salt = buf.DecodeUint32()
	m.SeqOutbound = buf.DecodeUint64()
	m.LastSeqInbound = buf.DecodeUint64()
	m.ReplayWindow = buf.DecodeUint64()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSaV2Dump defines message 'ipsec_sa_v2_dump'.
// Deprecated: the message will be removed in the future versions
type IpsecSaV2Dump struct {
	SaID uint32 `binapi:"u32,name=sa_id" json:"sa_id,omitempty"`
}

func (m *IpsecSaV2Dump) Reset()               { *m = IpsecSaV2Dump{} }
func (*IpsecSaV2Dump) GetMessageName() string { return "ipsec_sa_v2_dump" }
func (*IpsecSaV2Dump) GetCrcString() string   { return "2076c2f4" }
func (*IpsecSaV2Dump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSaV2Dump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SaID
	return size
}
func (m *IpsecSaV2Dump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SaID)
	return buf.Bytes(), nil
}
func (m *IpsecSaV2Dump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SaID = buf.DecodeUint32()
	return nil
}

// IpsecSaV3Details defines message 'ipsec_sa_v3_details'.
type IpsecSaV3Details struct {
	Entry          ipsec_types.IpsecSadEntryV3    `binapi:"ipsec_sad_entry_v3,name=entry" json:"entry,omitempty"`
	SwIfIndex      interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
	SeqOutbound    uint64                         `binapi:"u64,name=seq_outbound" json:"seq_outbound,omitempty"`
	LastSeqInbound uint64                         `binapi:"u64,name=last_seq_inbound" json:"last_seq_inbound,omitempty"`
	ReplayWindow   uint64                         `binapi:"u64,name=replay_window" json:"replay_window,omitempty"`
	StatIndex      uint32                         `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSaV3Details) Reset()               { *m = IpsecSaV3Details{} }
func (*IpsecSaV3Details) GetMessageName() string { return "ipsec_sa_v3_details" }
func (*IpsecSaV3Details) GetCrcString() string   { return "2fc991ee" }
func (*IpsecSaV3Details) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSaV3Details) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 4       // m.Entry.Tunnel.Instance
	size += 1       // m.Entry.Tunnel.Src.Af
	size += 1 * 16  // m.Entry.Tunnel.Src.Un
	size += 1       // m.Entry.Tunnel.Dst.Af
	size += 1 * 16  // m.Entry.Tunnel.Dst.Un
	size += 4       // m.Entry.Tunnel.SwIfIndex
	size += 4       // m.Entry.Tunnel.TableID
	size += 1       // m.Entry.Tunnel.EncapDecapFlags
	size += 1       // m.Entry.Tunnel.Mode
	size += 1       // m.Entry.Tunnel.Flags
	size += 1       // m.Entry.Tunnel.Dscp
	size += 1       // m.Entry.Tunnel.HopLimit
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	size += 4       // m.SwIfIndex
	size += 8       // m.SeqOutbound
	size += 8       // m.LastSeqInbound
	size += 8       // m.ReplayWindow
	size += 4       // m.StatIndex
	return size
}
func (m *IpsecSaV3Details) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint32(m.Entry.Tunnel.Instance)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Src.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dst.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(uint32(m.Entry.Tunnel.SwIfIndex))
	buf.EncodeUint32(m.Entry.Tunnel.TableID)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.EncapDecapFlags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Mode))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Flags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dscp))
	buf.EncodeUint8(m.Entry.Tunnel.HopLimit)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	buf.EncodeUint64(m.SeqOutbound)
	buf.EncodeUint64(m.LastSeqInbound)
	buf.EncodeUint64(m.ReplayWindow)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSaV3Details) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.Tunnel.Instance = buf.DecodeUint32()
	m.Entry.Tunnel.Src.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.Dst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Entry.Tunnel.TableID = buf.DecodeUint32()
	m.Entry.Tunnel.EncapDecapFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Entry.Tunnel.Flags = tunnel_types.TunnelFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Entry.Tunnel.HopLimit = buf.DecodeUint8()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.SeqOutbound = buf.DecodeUint64()
	m.LastSeqInbound = buf.DecodeUint64()
	m.ReplayWindow = buf.DecodeUint64()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSaV3Dump defines message 'ipsec_sa_v3_dump'.
type IpsecSaV3Dump struct {
	SaID uint32 `binapi:"u32,name=sa_id" json:"sa_id,omitempty"`
}

func (m *IpsecSaV3Dump) Reset()               { *m = IpsecSaV3Dump{} }
func (*IpsecSaV3Dump) GetMessageName() string { return "ipsec_sa_v3_dump" }
func (*IpsecSaV3Dump) GetCrcString() string   { return "2076c2f4" }
func (*IpsecSaV3Dump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSaV3Dump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SaID
	return size
}
func (m *IpsecSaV3Dump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SaID)
	return buf.Bytes(), nil
}
func (m *IpsecSaV3Dump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SaID = buf.DecodeUint32()
	return nil
}

// IpsecSaV4Details defines message 'ipsec_sa_v4_details'.
type IpsecSaV4Details struct {
	Entry          ipsec_types.IpsecSadEntryV3    `binapi:"ipsec_sad_entry_v3,name=entry" json:"entry,omitempty"`
	SwIfIndex      interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
	SeqOutbound    uint64                         `binapi:"u64,name=seq_outbound" json:"seq_outbound,omitempty"`
	LastSeqInbound uint64                         `binapi:"u64,name=last_seq_inbound" json:"last_seq_inbound,omitempty"`
	ReplayWindow   uint64                         `binapi:"u64,name=replay_window" json:"replay_window,omitempty"`
	ThreadIndex    uint32                         `binapi:"u32,name=thread_index" json:"thread_index,omitempty"`
	StatIndex      uint32                         `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSaV4Details) Reset()               { *m = IpsecSaV4Details{} }
func (*IpsecSaV4Details) GetMessageName() string { return "ipsec_sa_v4_details" }
func (*IpsecSaV4Details) GetCrcString() string   { return "87a322d7" }
func (*IpsecSaV4Details) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSaV4Details) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 4       // m.Entry.Tunnel.Instance
	size += 1       // m.Entry.Tunnel.Src.Af
	size += 1 * 16  // m.Entry.Tunnel.Src.Un
	size += 1       // m.Entry.Tunnel.Dst.Af
	size += 1 * 16  // m.Entry.Tunnel.Dst.Un
	size += 4       // m.Entry.Tunnel.SwIfIndex
	size += 4       // m.Entry.Tunnel.TableID
	size += 1       // m.Entry.Tunnel.EncapDecapFlags
	size += 1       // m.Entry.Tunnel.Mode
	size += 1       // m.Entry.Tunnel.Flags
	size += 1       // m.Entry.Tunnel.Dscp
	size += 1       // m.Entry.Tunnel.HopLimit
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	size += 4       // m.SwIfIndex
	size += 8       // m.SeqOutbound
	size += 8       // m.LastSeqInbound
	size += 8       // m.ReplayWindow
	size += 4       // m.ThreadIndex
	size += 4       // m.StatIndex
	return size
}
func (m *IpsecSaV4Details) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint32(m.Entry.Tunnel.Instance)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Src.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dst.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(uint32(m.Entry.Tunnel.SwIfIndex))
	buf.EncodeUint32(m.Entry.Tunnel.TableID)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.EncapDecapFlags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Mode))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Flags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dscp))
	buf.EncodeUint8(m.Entry.Tunnel.HopLimit)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	buf.EncodeUint64(m.SeqOutbound)
	buf.EncodeUint64(m.LastSeqInbound)
	buf.EncodeUint64(m.ReplayWindow)
	buf.EncodeUint32(m.ThreadIndex)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSaV4Details) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.Tunnel.Instance = buf.DecodeUint32()
	m.Entry.Tunnel.Src.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.Dst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Entry.Tunnel.TableID = buf.DecodeUint32()
	m.Entry.Tunnel.EncapDecapFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Entry.Tunnel.Flags = tunnel_types.TunnelFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Entry.Tunnel.HopLimit = buf.DecodeUint8()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.SeqOutbound = buf.DecodeUint64()
	m.LastSeqInbound = buf.DecodeUint64()
	m.ReplayWindow = buf.DecodeUint64()
	m.ThreadIndex = buf.DecodeUint32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSaV4Dump defines message 'ipsec_sa_v4_dump'.
type IpsecSaV4Dump struct {
	SaID uint32 `binapi:"u32,name=sa_id" json:"sa_id,omitempty"`
}

func (m *IpsecSaV4Dump) Reset()               { *m = IpsecSaV4Dump{} }
func (*IpsecSaV4Dump) GetMessageName() string { return "ipsec_sa_v4_dump" }
func (*IpsecSaV4Dump) GetCrcString() string   { return "2076c2f4" }
func (*IpsecSaV4Dump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSaV4Dump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SaID
	return size
}
func (m *IpsecSaV4Dump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SaID)
	return buf.Bytes(), nil
}
func (m *IpsecSaV4Dump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SaID = buf.DecodeUint32()
	return nil
}

// IpsecSaV5Details defines message 'ipsec_sa_v5_details'.
type IpsecSaV5Details struct {
	Entry          ipsec_types.IpsecSadEntryV4    `binapi:"ipsec_sad_entry_v4,name=entry" json:"entry,omitempty"`
	SwIfIndex      interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
	SeqOutbound    uint64                         `binapi:"u64,name=seq_outbound" json:"seq_outbound,omitempty"`
	LastSeqInbound uint64                         `binapi:"u64,name=last_seq_inbound" json:"last_seq_inbound,omitempty"`
	ReplayWindow   uint64                         `binapi:"u64,name=replay_window" json:"replay_window,omitempty"`
	ThreadIndex    uint32                         `binapi:"u32,name=thread_index" json:"thread_index,omitempty"`
	StatIndex      uint32                         `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSaV5Details) Reset()               { *m = IpsecSaV5Details{} }
func (*IpsecSaV5Details) GetMessageName() string { return "ipsec_sa_v5_details" }
func (*IpsecSaV5Details) GetCrcString() string   { return "3cfecfbd" }
func (*IpsecSaV5Details) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSaV5Details) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 4       // m.Entry.Tunnel.Instance
	size += 1       // m.Entry.Tunnel.Src.Af
	size += 1 * 16  // m.Entry.Tunnel.Src.Un
	size += 1       // m.Entry.Tunnel.Dst.Af
	size += 1 * 16  // m.Entry.Tunnel.Dst.Un
	size += 4       // m.Entry.Tunnel.SwIfIndex
	size += 4       // m.Entry.Tunnel.TableID
	size += 1       // m.Entry.Tunnel.EncapDecapFlags
	size += 1       // m.Entry.Tunnel.Mode
	size += 1       // m.Entry.Tunnel.Flags
	size += 1       // m.Entry.Tunnel.Dscp
	size += 1       // m.Entry.Tunnel.HopLimit
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	size += 4       // m.Entry.AntiReplayWindowSize
	size += 4       // m.SwIfIndex
	size += 8       // m.SeqOutbound
	size += 8       // m.LastSeqInbound
	size += 8       // m.ReplayWindow
	size += 4       // m.ThreadIndex
	size += 4       // m.StatIndex
	return size
}
func (m *IpsecSaV5Details) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint32(m.Entry.Tunnel.Instance)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Src.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dst.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(uint32(m.Entry.Tunnel.SwIfIndex))
	buf.EncodeUint32(m.Entry.Tunnel.TableID)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.EncapDecapFlags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Mode))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Flags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dscp))
	buf.EncodeUint8(m.Entry.Tunnel.HopLimit)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	buf.EncodeUint32(m.Entry.AntiReplayWindowSize)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	buf.EncodeUint64(m.SeqOutbound)
	buf.EncodeUint64(m.LastSeqInbound)
	buf.EncodeUint64(m.ReplayWindow)
	buf.EncodeUint32(m.ThreadIndex)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSaV5Details) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.Tunnel.Instance = buf.DecodeUint32()
	m.Entry.Tunnel.Src.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.Dst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Entry.Tunnel.TableID = buf.DecodeUint32()
	m.Entry.Tunnel.EncapDecapFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Entry.Tunnel.Flags = tunnel_types.TunnelFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Entry.Tunnel.HopLimit = buf.DecodeUint8()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	m.Entry.AntiReplayWindowSize = buf.DecodeUint32()
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.SeqOutbound = buf.DecodeUint64()
	m.LastSeqInbound = buf.DecodeUint64()
	m.ReplayWindow = buf.DecodeUint64()
	m.ThreadIndex = buf.DecodeUint32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSaV5Dump defines message 'ipsec_sa_v5_dump'.
type IpsecSaV5Dump struct {
	SaID uint32 `binapi:"u32,name=sa_id" json:"sa_id,omitempty"`
}

func (m *IpsecSaV5Dump) Reset()               { *m = IpsecSaV5Dump{} }
func (*IpsecSaV5Dump) GetMessageName() string { return "ipsec_sa_v5_dump" }
func (*IpsecSaV5Dump) GetCrcString() string   { return "2076c2f4" }
func (*IpsecSaV5Dump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSaV5Dump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SaID
	return size
}
func (m *IpsecSaV5Dump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SaID)
	return buf.Bytes(), nil
}
func (m *IpsecSaV5Dump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SaID = buf.DecodeUint32()
	return nil
}

// An API to bind an SAD entry to a specific worker
//   - sa_id - the id of the SA to bind
//   - worker - the worker's index to which the SA will be bound to
//
// IpsecSadBind defines message 'ipsec_sad_bind'.
type IpsecSadBind struct {
	SaID   uint32 `binapi:"u32,name=sa_id" json:"sa_id,omitempty"`
	Worker uint32 `binapi:"u32,name=worker" json:"worker,omitempty"`
}

func (m *IpsecSadBind) Reset()               { *m = IpsecSadBind{} }
func (*IpsecSadBind) GetMessageName() string { return "ipsec_sad_bind" }
func (*IpsecSadBind) GetCrcString() string   { return "0649c0d9" }
func (*IpsecSadBind) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadBind) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SaID
	size += 4 // m.Worker
	return size
}
func (m *IpsecSadBind) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SaID)
	buf.EncodeUint32(m.Worker)
	return buf.Bytes(), nil
}
func (m *IpsecSadBind) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SaID = buf.DecodeUint32()
	m.Worker = buf.DecodeUint32()
	return nil
}

// IpsecSadBindReply defines message 'ipsec_sad_bind_reply'.
type IpsecSadBindReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecSadBindReply) Reset()               { *m = IpsecSadBindReply{} }
func (*IpsecSadBindReply) GetMessageName() string { return "ipsec_sad_bind_reply" }
func (*IpsecSadBindReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecSadBindReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadBindReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecSadBindReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecSadBindReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// IpsecSadEntryAdd defines message 'ipsec_sad_entry_add'.
type IpsecSadEntryAdd struct {
	Entry ipsec_types.IpsecSadEntryV3 `binapi:"ipsec_sad_entry_v3,name=entry" json:"entry,omitempty"`
}

func (m *IpsecSadEntryAdd) Reset()               { *m = IpsecSadEntryAdd{} }
func (*IpsecSadEntryAdd) GetMessageName() string { return "ipsec_sad_entry_add" }
func (*IpsecSadEntryAdd) GetCrcString() string   { return "50229353" }
func (*IpsecSadEntryAdd) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadEntryAdd) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 4       // m.Entry.Tunnel.Instance
	size += 1       // m.Entry.Tunnel.Src.Af
	size += 1 * 16  // m.Entry.Tunnel.Src.Un
	size += 1       // m.Entry.Tunnel.Dst.Af
	size += 1 * 16  // m.Entry.Tunnel.Dst.Un
	size += 4       // m.Entry.Tunnel.SwIfIndex
	size += 4       // m.Entry.Tunnel.TableID
	size += 1       // m.Entry.Tunnel.EncapDecapFlags
	size += 1       // m.Entry.Tunnel.Mode
	size += 1       // m.Entry.Tunnel.Flags
	size += 1       // m.Entry.Tunnel.Dscp
	size += 1       // m.Entry.Tunnel.HopLimit
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	return size
}
func (m *IpsecSadEntryAdd) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint32(m.Entry.Tunnel.Instance)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Src.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dst.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(uint32(m.Entry.Tunnel.SwIfIndex))
	buf.EncodeUint32(m.Entry.Tunnel.TableID)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.EncapDecapFlags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Mode))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Flags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dscp))
	buf.EncodeUint8(m.Entry.Tunnel.HopLimit)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAdd) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.Tunnel.Instance = buf.DecodeUint32()
	m.Entry.Tunnel.Src.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.Dst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Entry.Tunnel.TableID = buf.DecodeUint32()
	m.Entry.Tunnel.EncapDecapFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Entry.Tunnel.Flags = tunnel_types.TunnelFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Entry.Tunnel.HopLimit = buf.DecodeUint8()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	return nil
}

// IPsec: Add/delete Security Association Database entry
//   - entry - Entry to add or delete
//
// IpsecSadEntryAddDel defines message 'ipsec_sad_entry_add_del'.
// Deprecated: the message will be removed in the future versions
type IpsecSadEntryAddDel struct {
	IsAdd bool                      `binapi:"bool,name=is_add" json:"is_add,omitempty"`
	Entry ipsec_types.IpsecSadEntry `binapi:"ipsec_sad_entry,name=entry" json:"entry,omitempty"`
}

func (m *IpsecSadEntryAddDel) Reset()               { *m = IpsecSadEntryAddDel{} }
func (*IpsecSadEntryAddDel) GetMessageName() string { return "ipsec_sad_entry_add_del" }
func (*IpsecSadEntryAddDel) GetCrcString() string   { return "ab64b5c6" }
func (*IpsecSadEntryAddDel) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadEntryAddDel) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 1       // m.IsAdd
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 1       // m.Entry.TunnelSrc.Af
	size += 1 * 16  // m.Entry.TunnelSrc.Un
	size += 1       // m.Entry.TunnelDst.Af
	size += 1 * 16  // m.Entry.TunnelDst.Un
	size += 4       // m.Entry.TxTableID
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	return size
}
func (m *IpsecSadEntryAddDel) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeBool(m.IsAdd)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint8(uint8(m.Entry.TunnelSrc.Af))
	buf.EncodeBytes(m.Entry.TunnelSrc.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.TunnelDst.Af))
	buf.EncodeBytes(m.Entry.TunnelDst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(m.Entry.TxTableID)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddDel) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.IsAdd = buf.DecodeBool()
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.TunnelSrc.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.TunnelSrc.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.TunnelDst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.TunnelDst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.TxTableID = buf.DecodeUint32()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	return nil
}

// IpsecSadEntryAddDelReply defines message 'ipsec_sad_entry_add_del_reply'.
// Deprecated: the message will be removed in the future versions
type IpsecSadEntryAddDelReply struct {
	Retval    int32  `binapi:"i32,name=retval" json:"retval,omitempty"`
	StatIndex uint32 `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSadEntryAddDelReply) Reset()               { *m = IpsecSadEntryAddDelReply{} }
func (*IpsecSadEntryAddDelReply) GetMessageName() string { return "ipsec_sad_entry_add_del_reply" }
func (*IpsecSadEntryAddDelReply) GetCrcString() string   { return "9ffac24b" }
func (*IpsecSadEntryAddDelReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadEntryAddDelReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	size += 4 // m.StatIndex
	return size
}
func (m *IpsecSadEntryAddDelReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddDelReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSadEntryAddDelV2 defines message 'ipsec_sad_entry_add_del_v2'.
// Deprecated: the message will be removed in the future versions
type IpsecSadEntryAddDelV2 struct {
	IsAdd bool                        `binapi:"bool,name=is_add" json:"is_add,omitempty"`
	Entry ipsec_types.IpsecSadEntryV2 `binapi:"ipsec_sad_entry_v2,name=entry" json:"entry,omitempty"`
}

func (m *IpsecSadEntryAddDelV2) Reset()               { *m = IpsecSadEntryAddDelV2{} }
func (*IpsecSadEntryAddDelV2) GetMessageName() string { return "ipsec_sad_entry_add_del_v2" }
func (*IpsecSadEntryAddDelV2) GetCrcString() string   { return "aca78b27" }
func (*IpsecSadEntryAddDelV2) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadEntryAddDelV2) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 1       // m.IsAdd
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 1       // m.Entry.TunnelSrc.Af
	size += 1 * 16  // m.Entry.TunnelSrc.Un
	size += 1       // m.Entry.TunnelDst.Af
	size += 1 * 16  // m.Entry.TunnelDst.Un
	size += 1       // m.Entry.TunnelFlags
	size += 1       // m.Entry.Dscp
	size += 4       // m.Entry.TxTableID
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	return size
}
func (m *IpsecSadEntryAddDelV2) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeBool(m.IsAdd)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint8(uint8(m.Entry.TunnelSrc.Af))
	buf.EncodeBytes(m.Entry.TunnelSrc.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.TunnelDst.Af))
	buf.EncodeBytes(m.Entry.TunnelDst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.TunnelFlags))
	buf.EncodeUint8(uint8(m.Entry.Dscp))
	buf.EncodeUint32(m.Entry.TxTableID)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddDelV2) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.IsAdd = buf.DecodeBool()
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.TunnelSrc.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.TunnelSrc.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.TunnelDst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.TunnelDst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.TunnelFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Entry.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Entry.TxTableID = buf.DecodeUint32()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	return nil
}

// IpsecSadEntryAddDelV2Reply defines message 'ipsec_sad_entry_add_del_v2_reply'.
// Deprecated: the message will be removed in the future versions
type IpsecSadEntryAddDelV2Reply struct {
	Retval    int32  `binapi:"i32,name=retval" json:"retval,omitempty"`
	StatIndex uint32 `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSadEntryAddDelV2Reply) Reset()               { *m = IpsecSadEntryAddDelV2Reply{} }
func (*IpsecSadEntryAddDelV2Reply) GetMessageName() string { return "ipsec_sad_entry_add_del_v2_reply" }
func (*IpsecSadEntryAddDelV2Reply) GetCrcString() string   { return "9ffac24b" }
func (*IpsecSadEntryAddDelV2Reply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadEntryAddDelV2Reply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	size += 4 // m.StatIndex
	return size
}
func (m *IpsecSadEntryAddDelV2Reply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddDelV2Reply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSadEntryAddDelV3 defines message 'ipsec_sad_entry_add_del_v3'.
type IpsecSadEntryAddDelV3 struct {
	IsAdd bool                        `binapi:"bool,name=is_add" json:"is_add,omitempty"`
	Entry ipsec_types.IpsecSadEntryV3 `binapi:"ipsec_sad_entry_v3,name=entry" json:"entry,omitempty"`
}

func (m *IpsecSadEntryAddDelV3) Reset()               { *m = IpsecSadEntryAddDelV3{} }
func (*IpsecSadEntryAddDelV3) GetMessageName() string { return "ipsec_sad_entry_add_del_v3" }
func (*IpsecSadEntryAddDelV3) GetCrcString() string   { return "c77ebd92" }
func (*IpsecSadEntryAddDelV3) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadEntryAddDelV3) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 1       // m.IsAdd
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 4       // m.Entry.Tunnel.Instance
	size += 1       // m.Entry.Tunnel.Src.Af
	size += 1 * 16  // m.Entry.Tunnel.Src.Un
	size += 1       // m.Entry.Tunnel.Dst.Af
	size += 1 * 16  // m.Entry.Tunnel.Dst.Un
	size += 4       // m.Entry.Tunnel.SwIfIndex
	size += 4       // m.Entry.Tunnel.TableID
	size += 1       // m.Entry.Tunnel.EncapDecapFlags
	size += 1       // m.Entry.Tunnel.Mode
	size += 1       // m.Entry.Tunnel.Flags
	size += 1       // m.Entry.Tunnel.Dscp
	size += 1       // m.Entry.Tunnel.HopLimit
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	return size
}
func (m *IpsecSadEntryAddDelV3) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeBool(m.IsAdd)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint32(m.Entry.Tunnel.Instance)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Src.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dst.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(uint32(m.Entry.Tunnel.SwIfIndex))
	buf.EncodeUint32(m.Entry.Tunnel.TableID)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.EncapDecapFlags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Mode))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Flags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dscp))
	buf.EncodeUint8(m.Entry.Tunnel.HopLimit)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddDelV3) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.IsAdd = buf.DecodeBool()
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.Tunnel.Instance = buf.DecodeUint32()
	m.Entry.Tunnel.Src.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.Dst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Entry.Tunnel.TableID = buf.DecodeUint32()
	m.Entry.Tunnel.EncapDecapFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Entry.Tunnel.Flags = tunnel_types.TunnelFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Entry.Tunnel.HopLimit = buf.DecodeUint8()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	return nil
}

// IpsecSadEntryAddDelV3Reply defines message 'ipsec_sad_entry_add_del_v3_reply'.
type IpsecSadEntryAddDelV3Reply struct {
	Retval    int32  `binapi:"i32,name=retval" json:"retval,omitempty"`
	StatIndex uint32 `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSadEntryAddDelV3Reply) Reset()               { *m = IpsecSadEntryAddDelV3Reply{} }
func (*IpsecSadEntryAddDelV3Reply) GetMessageName() string { return "ipsec_sad_entry_add_del_v3_reply" }
func (*IpsecSadEntryAddDelV3Reply) GetCrcString() string   { return "9ffac24b" }
func (*IpsecSadEntryAddDelV3Reply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadEntryAddDelV3Reply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	size += 4 // m.StatIndex
	return size
}
func (m *IpsecSadEntryAddDelV3Reply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddDelV3Reply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSadEntryAddReply defines message 'ipsec_sad_entry_add_reply'.
type IpsecSadEntryAddReply struct {
	Retval    int32  `binapi:"i32,name=retval" json:"retval,omitempty"`
	StatIndex uint32 `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSadEntryAddReply) Reset()               { *m = IpsecSadEntryAddReply{} }
func (*IpsecSadEntryAddReply) GetMessageName() string { return "ipsec_sad_entry_add_reply" }
func (*IpsecSadEntryAddReply) GetCrcString() string   { return "9ffac24b" }
func (*IpsecSadEntryAddReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadEntryAddReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	size += 4 // m.StatIndex
	return size
}
func (m *IpsecSadEntryAddReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSadEntryAddV2 defines message 'ipsec_sad_entry_add_v2'.
type IpsecSadEntryAddV2 struct {
	Entry ipsec_types.IpsecSadEntryV4 `binapi:"ipsec_sad_entry_v4,name=entry" json:"entry,omitempty"`
}

func (m *IpsecSadEntryAddV2) Reset()               { *m = IpsecSadEntryAddV2{} }
func (*IpsecSadEntryAddV2) GetMessageName() string { return "ipsec_sad_entry_add_v2" }
func (*IpsecSadEntryAddV2) GetCrcString() string   { return "9611297a" }
func (*IpsecSadEntryAddV2) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadEntryAddV2) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4       // m.Entry.SadID
	size += 4       // m.Entry.Spi
	size += 4       // m.Entry.Protocol
	size += 4       // m.Entry.CryptoAlgorithm
	size += 1       // m.Entry.CryptoKey.Length
	size += 1 * 128 // m.Entry.CryptoKey.Data
	size += 4       // m.Entry.IntegrityAlgorithm
	size += 1       // m.Entry.IntegrityKey.Length
	size += 1 * 128 // m.Entry.IntegrityKey.Data
	size += 4       // m.Entry.Flags
	size += 4       // m.Entry.Tunnel.Instance
	size += 1       // m.Entry.Tunnel.Src.Af
	size += 1 * 16  // m.Entry.Tunnel.Src.Un
	size += 1       // m.Entry.Tunnel.Dst.Af
	size += 1 * 16  // m.Entry.Tunnel.Dst.Un
	size += 4       // m.Entry.Tunnel.SwIfIndex
	size += 4       // m.Entry.Tunnel.TableID
	size += 1       // m.Entry.Tunnel.EncapDecapFlags
	size += 1       // m.Entry.Tunnel.Mode
	size += 1       // m.Entry.Tunnel.Flags
	size += 1       // m.Entry.Tunnel.Dscp
	size += 1       // m.Entry.Tunnel.HopLimit
	size += 4       // m.Entry.Salt
	size += 2       // m.Entry.UDPSrcPort
	size += 2       // m.Entry.UDPDstPort
	size += 4       // m.Entry.AntiReplayWindowSize
	return size
}
func (m *IpsecSadEntryAddV2) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Entry.SadID)
	buf.EncodeUint32(m.Entry.Spi)
	buf.EncodeUint32(uint32(m.Entry.Protocol))
	buf.EncodeUint32(uint32(m.Entry.CryptoAlgorithm))
	buf.EncodeUint8(m.Entry.CryptoKey.Length)
	buf.EncodeBytes(m.Entry.CryptoKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.IntegrityAlgorithm))
	buf.EncodeUint8(m.Entry.IntegrityKey.Length)
	buf.EncodeBytes(m.Entry.IntegrityKey.Data, 128)
	buf.EncodeUint32(uint32(m.Entry.Flags))
	buf.EncodeUint32(m.Entry.Tunnel.Instance)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Src.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dst.Af))
	buf.EncodeBytes(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(uint32(m.Entry.Tunnel.SwIfIndex))
	buf.EncodeUint32(m.Entry.Tunnel.TableID)
	buf.EncodeUint8(uint8(m.Entry.Tunnel.EncapDecapFlags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Mode))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Flags))
	buf.EncodeUint8(uint8(m.Entry.Tunnel.Dscp))
	buf.EncodeUint8(m.Entry.Tunnel.HopLimit)
	buf.EncodeUint32(m.Entry.Salt)
	buf.EncodeUint16(m.Entry.UDPSrcPort)
	buf.EncodeUint16(m.Entry.UDPDstPort)
	buf.EncodeUint32(m.Entry.AntiReplayWindowSize)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddV2) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Entry.SadID = buf.DecodeUint32()
	m.Entry.Spi = buf.DecodeUint32()
	m.Entry.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Entry.CryptoAlgorithm = ipsec_types.IpsecCryptoAlg(buf.DecodeUint32())
	m.Entry.CryptoKey.Length = buf.DecodeUint8()
	m.Entry.CryptoKey.Data = make([]byte, 128)
	copy(m.Entry.CryptoKey.Data, buf.DecodeBytes(len(m.Entry.CryptoKey.Data)))
	m.Entry.IntegrityAlgorithm = ipsec_types.IpsecIntegAlg(buf.DecodeUint32())
	m.Entry.IntegrityKey.Length = buf.DecodeUint8()
	m.Entry.IntegrityKey.Data = make([]byte, 128)
	copy(m.Entry.IntegrityKey.Data, buf.DecodeBytes(len(m.Entry.IntegrityKey.Data)))
	m.Entry.Flags = ipsec_types.IpsecSadFlags(buf.DecodeUint32())
	m.Entry.Tunnel.Instance = buf.DecodeUint32()
	m.Entry.Tunnel.Src.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Src.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.Dst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.Tunnel.Dst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.Tunnel.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Entry.Tunnel.TableID = buf.DecodeUint32()
	m.Entry.Tunnel.EncapDecapFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Entry.Tunnel.Flags = tunnel_types.TunnelFlags(buf.DecodeUint8())
	m.Entry.Tunnel.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Entry.Tunnel.HopLimit = buf.DecodeUint8()
	m.Entry.Salt = buf.DecodeUint32()
	m.Entry.UDPSrcPort = buf.DecodeUint16()
	m.Entry.UDPDstPort = buf.DecodeUint16()
	m.Entry.AntiReplayWindowSize = buf.DecodeUint32()
	return nil
}

// IpsecSadEntryAddV2Reply defines message 'ipsec_sad_entry_add_v2_reply'.
type IpsecSadEntryAddV2Reply struct {
	Retval    int32  `binapi:"i32,name=retval" json:"retval,omitempty"`
	StatIndex uint32 `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSadEntryAddV2Reply) Reset()               { *m = IpsecSadEntryAddV2Reply{} }
func (*IpsecSadEntryAddV2Reply) GetMessageName() string { return "ipsec_sad_entry_add_v2_reply" }
func (*IpsecSadEntryAddV2Reply) GetCrcString() string   { return "9ffac24b" }
func (*IpsecSadEntryAddV2Reply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadEntryAddV2Reply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	size += 4 // m.StatIndex
	return size
}
func (m *IpsecSadEntryAddV2Reply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryAddV2Reply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IpsecSadEntryDel defines message 'ipsec_sad_entry_del'.
type IpsecSadEntryDel struct {
	ID uint32 `binapi:"u32,name=id" json:"id,omitempty"`
}

func (m *IpsecSadEntryDel) Reset()               { *m = IpsecSadEntryDel{} }
func (*IpsecSadEntryDel) GetMessageName() string { return "ipsec_sad_entry_del" }
func (*IpsecSadEntryDel) GetCrcString() string   { return "3a91bde5" }
func (*IpsecSadEntryDel) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadEntryDel) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.ID
	return size
}
func (m *IpsecSadEntryDel) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.ID)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryDel) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.ID = buf.DecodeUint32()
	return nil
}

// IpsecSadEntryDelReply defines message 'ipsec_sad_entry_del_reply'.
type IpsecSadEntryDelReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecSadEntryDelReply) Reset()               { *m = IpsecSadEntryDelReply{} }
func (*IpsecSadEntryDelReply) GetMessageName() string { return "ipsec_sad_entry_del_reply" }
func (*IpsecSadEntryDelReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecSadEntryDelReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadEntryDelReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecSadEntryDelReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryDelReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// An API to update the tunnel parameters and the ports associated with an SA
//
//	Used in the NAT-T case when the NAT data changes
//	- sa_id - the id of the SA to update
//	- is_tun - update the tunnel if non-zero, else update only the ports
//	- tunnel - sender context, to match reply w/ request
//	- udp_src_port - new src port for NAT-T. Used if different from 0xffff
//	- udp_dst_port - new dst port for NAT-T. Used if different from 0xffff
//
// IpsecSadEntryUpdate defines message 'ipsec_sad_entry_update'.
type IpsecSadEntryUpdate struct {
	SadID      uint32              `binapi:"u32,name=sad_id" json:"sad_id,omitempty"`
	IsTun      bool                `binapi:"bool,name=is_tun" json:"is_tun,omitempty"`
	Tunnel     tunnel_types.Tunnel `binapi:"tunnel,name=tunnel" json:"tunnel,omitempty"`
	UDPSrcPort uint16              `binapi:"u16,name=udp_src_port,default=65535" json:"udp_src_port,omitempty"`
	UDPDstPort uint16              `binapi:"u16,name=udp_dst_port,default=65535" json:"udp_dst_port,omitempty"`
}

func (m *IpsecSadEntryUpdate) Reset()               { *m = IpsecSadEntryUpdate{} }
func (*IpsecSadEntryUpdate) GetMessageName() string { return "ipsec_sad_entry_update" }
func (*IpsecSadEntryUpdate) GetCrcString() string   { return "1412af86" }
func (*IpsecSadEntryUpdate) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadEntryUpdate) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4      // m.SadID
	size += 1      // m.IsTun
	size += 4      // m.Tunnel.Instance
	size += 1      // m.Tunnel.Src.Af
	size += 1 * 16 // m.Tunnel.Src.Un
	size += 1      // m.Tunnel.Dst.Af
	size += 1 * 16 // m.Tunnel.Dst.Un
	size += 4      // m.Tunnel.SwIfIndex
	size += 4      // m.Tunnel.TableID
	size += 1      // m.Tunnel.EncapDecapFlags
	size += 1      // m.Tunnel.Mode
	size += 1      // m.Tunnel.Flags
	size += 1      // m.Tunnel.Dscp
	size += 1      // m.Tunnel.HopLimit
	size += 2      // m.UDPSrcPort
	size += 2      // m.UDPDstPort
	return size
}
func (m *IpsecSadEntryUpdate) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SadID)
	buf.EncodeBool(m.IsTun)
	buf.EncodeUint32(m.Tunnel.Instance)
	buf.EncodeUint8(uint8(m.Tunnel.Src.Af))
	buf.EncodeBytes(m.Tunnel.Src.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Tunnel.Dst.Af))
	buf.EncodeBytes(m.Tunnel.Dst.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(uint32(m.Tunnel.SwIfIndex))
	buf.EncodeUint32(m.Tunnel.TableID)
	buf.EncodeUint8(uint8(m.Tunnel.EncapDecapFlags))
	buf.EncodeUint8(uint8(m.Tunnel.Mode))
	buf.EncodeUint8(uint8(m.Tunnel.Flags))
	buf.EncodeUint8(uint8(m.Tunnel.Dscp))
	buf.EncodeUint8(m.Tunnel.HopLimit)
	buf.EncodeUint16(m.UDPSrcPort)
	buf.EncodeUint16(m.UDPDstPort)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryUpdate) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SadID = buf.DecodeUint32()
	m.IsTun = buf.DecodeBool()
	m.Tunnel.Instance = buf.DecodeUint32()
	m.Tunnel.Src.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Tunnel.Src.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Tunnel.Dst.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Tunnel.Dst.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Tunnel.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Tunnel.TableID = buf.DecodeUint32()
	m.Tunnel.EncapDecapFlags = tunnel_types.TunnelEncapDecapFlags(buf.DecodeUint8())
	m.Tunnel.Mode = tunnel_types.TunnelMode(buf.DecodeUint8())
	m.Tunnel.Flags = tunnel_types.TunnelFlags(buf.DecodeUint8())
	m.Tunnel.Dscp = ip_types.IPDscp(buf.DecodeUint8())
	m.Tunnel.HopLimit = buf.DecodeUint8()
	m.UDPSrcPort = buf.DecodeUint16()
	m.UDPDstPort = buf.DecodeUint16()
	return nil
}

// IpsecSadEntryUpdateReply defines message 'ipsec_sad_entry_update_reply'.
type IpsecSadEntryUpdateReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecSadEntryUpdateReply) Reset()               { *m = IpsecSadEntryUpdateReply{} }
func (*IpsecSadEntryUpdateReply) GetMessageName() string { return "ipsec_sad_entry_update_reply" }
func (*IpsecSadEntryUpdateReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecSadEntryUpdateReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadEntryUpdateReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecSadEntryUpdateReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecSadEntryUpdateReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// IpsecSadUnbind defines message 'ipsec_sad_unbind'.
type IpsecSadUnbind struct {
	SaID uint32 `binapi:"u32,name=sa_id" json:"sa_id,omitempty"`
}

func (m *IpsecSadUnbind) Reset()               { *m = IpsecSadUnbind{} }
func (*IpsecSadUnbind) GetMessageName() string { return "ipsec_sad_unbind" }
func (*IpsecSadUnbind) GetCrcString() string   { return "2076c2f4" }
func (*IpsecSadUnbind) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSadUnbind) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SaID
	return size
}
func (m *IpsecSadUnbind) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SaID)
	return buf.Bytes(), nil
}
func (m *IpsecSadUnbind) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SaID = buf.DecodeUint32()
	return nil
}

// IpsecSadUnbindReply defines message 'ipsec_sad_unbind_reply'.
type IpsecSadUnbindReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecSadUnbindReply) Reset()               { *m = IpsecSadUnbindReply{} }
func (*IpsecSadUnbindReply) GetMessageName() string { return "ipsec_sad_unbind_reply" }
func (*IpsecSadUnbindReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecSadUnbindReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSadUnbindReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecSadUnbindReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecSadUnbindReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// Select IPsec backend
//   - protocol - IPsec protocol (value from ipsec_protocol_t)
//   - index - backend index
//
// IpsecSelectBackend defines message 'ipsec_select_backend'.
type IpsecSelectBackend struct {
	Protocol ipsec_types.IpsecProto `binapi:"ipsec_proto,name=protocol" json:"protocol,omitempty"`
	Index    uint8                  `binapi:"u8,name=index" json:"index,omitempty"`
}

func (m *IpsecSelectBackend) Reset()               { *m = IpsecSelectBackend{} }
func (*IpsecSelectBackend) GetMessageName() string { return "ipsec_select_backend" }
func (*IpsecSelectBackend) GetCrcString() string   { return "5bcfd3b7" }
func (*IpsecSelectBackend) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSelectBackend) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Protocol
	size += 1 // m.Index
	return size
}
func (m *IpsecSelectBackend) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(uint32(m.Protocol))
	buf.EncodeUint8(m.Index)
	return buf.Bytes(), nil
}
func (m *IpsecSelectBackend) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Protocol = ipsec_types.IpsecProto(buf.DecodeUint32())
	m.Index = buf.DecodeUint8()
	return nil
}

// IpsecSelectBackendReply defines message 'ipsec_select_backend_reply'.
type IpsecSelectBackendReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecSelectBackendReply) Reset()               { *m = IpsecSelectBackendReply{} }
func (*IpsecSelectBackendReply) GetMessageName() string { return "ipsec_select_backend_reply" }
func (*IpsecSelectBackendReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecSelectBackendReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSelectBackendReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecSelectBackendReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecSelectBackendReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// IPsec Set Async mode
//   - async_enable - ipsec async mode on or off
//
// IpsecSetAsyncMode defines message 'ipsec_set_async_mode'.
type IpsecSetAsyncMode struct {
	AsyncEnable bool `binapi:"bool,name=async_enable" json:"async_enable,omitempty"`
}

func (m *IpsecSetAsyncMode) Reset()               { *m = IpsecSetAsyncMode{} }
func (*IpsecSetAsyncMode) GetMessageName() string { return "ipsec_set_async_mode" }
func (*IpsecSetAsyncMode) GetCrcString() string   { return "a6465f7c" }
func (*IpsecSetAsyncMode) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSetAsyncMode) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 1 // m.AsyncEnable
	return size
}
func (m *IpsecSetAsyncMode) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeBool(m.AsyncEnable)
	return buf.Bytes(), nil
}
func (m *IpsecSetAsyncMode) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.AsyncEnable = buf.DecodeBool()
	return nil
}

// IpsecSetAsyncModeReply defines message 'ipsec_set_async_mode_reply'.
type IpsecSetAsyncModeReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecSetAsyncModeReply) Reset()               { *m = IpsecSetAsyncModeReply{} }
func (*IpsecSetAsyncModeReply) GetMessageName() string { return "ipsec_set_async_mode_reply" }
func (*IpsecSetAsyncModeReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecSetAsyncModeReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSetAsyncModeReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecSetAsyncModeReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecSetAsyncModeReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// IPsec: Add/delete Security Policy Database
//   - is_add - add SPD if non-zero, else delete
//   - spd_id - SPD instance id (control plane allocated)
//
// IpsecSpdAddDel defines message 'ipsec_spd_add_del'.
type IpsecSpdAddDel struct {
	IsAdd bool   `binapi:"bool,name=is_add" json:"is_add,omitempty"`
	SpdID uint32 `binapi:"u32,name=spd_id" json:"spd_id,omitempty"`
}

func (m *IpsecSpdAddDel) Reset()               { *m = IpsecSpdAddDel{} }
func (*IpsecSpdAddDel) GetMessageName() string { return "ipsec_spd_add_del" }
func (*IpsecSpdAddDel) GetCrcString() string   { return "20e89a95" }
func (*IpsecSpdAddDel) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSpdAddDel) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 1 // m.IsAdd
	size += 4 // m.SpdID
	return size
}
func (m *IpsecSpdAddDel) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeBool(m.IsAdd)
	buf.EncodeUint32(m.SpdID)
	return buf.Bytes(), nil
}
func (m *IpsecSpdAddDel) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.IsAdd = buf.DecodeBool()
	m.SpdID = buf.DecodeUint32()
	return nil
}

// IpsecSpdAddDelReply defines message 'ipsec_spd_add_del_reply'.
type IpsecSpdAddDelReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecSpdAddDelReply) Reset()               { *m = IpsecSpdAddDelReply{} }
func (*IpsecSpdAddDelReply) GetMessageName() string { return "ipsec_spd_add_del_reply" }
func (*IpsecSpdAddDelReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecSpdAddDelReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSpdAddDelReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecSpdAddDelReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecSpdAddDelReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// IPsec policy database response
//
//	€param entry - The SPD entry.
//	- bytes - byte count of packets matching this policy
//	- packets - count of packets matching this policy
//
// IpsecSpdDetails defines message 'ipsec_spd_details'.
type IpsecSpdDetails struct {
	Entry ipsec_types.IpsecSpdEntry `binapi:"ipsec_spd_entry,name=entry" json:"entry,omitempty"`
}

func (m *IpsecSpdDetails) Reset()               { *m = IpsecSpdDetails{} }
func (*IpsecSpdDetails) GetMessageName() string { return "ipsec_spd_details" }
func (*IpsecSpdDetails) GetCrcString() string   { return "5813d7a2" }
func (*IpsecSpdDetails) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSpdDetails) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4      // m.Entry.SpdID
	size += 4      // m.Entry.Priority
	size += 1      // m.Entry.IsOutbound
	size += 4      // m.Entry.SaID
	size += 4      // m.Entry.Policy
	size += 1      // m.Entry.Protocol
	size += 1      // m.Entry.RemoteAddressStart.Af
	size += 1 * 16 // m.Entry.RemoteAddressStart.Un
	size += 1      // m.Entry.RemoteAddressStop.Af
	size += 1 * 16 // m.Entry.RemoteAddressStop.Un
	size += 1      // m.Entry.LocalAddressStart.Af
	size += 1 * 16 // m.Entry.LocalAddressStart.Un
	size += 1      // m.Entry.LocalAddressStop.Af
	size += 1 * 16 // m.Entry.LocalAddressStop.Un
	size += 2      // m.Entry.RemotePortStart
	size += 2      // m.Entry.RemotePortStop
	size += 2      // m.Entry.LocalPortStart
	size += 2      // m.Entry.LocalPortStop
	return size
}
func (m *IpsecSpdDetails) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.Entry.SpdID)
	buf.EncodeInt32(m.Entry.Priority)
	buf.EncodeBool(m.Entry.IsOutbound)
	buf.EncodeUint32(m.Entry.SaID)
	buf.EncodeUint32(uint32(m.Entry.Policy))
	buf.EncodeUint8(m.Entry.Protocol)
	buf.EncodeUint8(uint8(m.Entry.RemoteAddressStart.Af))
	buf.EncodeBytes(m.Entry.RemoteAddressStart.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.RemoteAddressStop.Af))
	buf.EncodeBytes(m.Entry.RemoteAddressStop.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.LocalAddressStart.Af))
	buf.EncodeBytes(m.Entry.LocalAddressStart.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.LocalAddressStop.Af))
	buf.EncodeBytes(m.Entry.LocalAddressStop.Un.XXX_UnionData[:], 16)
	buf.EncodeUint16(m.Entry.RemotePortStart)
	buf.EncodeUint16(m.Entry.RemotePortStop)
	buf.EncodeUint16(m.Entry.LocalPortStart)
	buf.EncodeUint16(m.Entry.LocalPortStop)
	return buf.Bytes(), nil
}
func (m *IpsecSpdDetails) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Entry.SpdID = buf.DecodeUint32()
	m.Entry.Priority = buf.DecodeInt32()
	m.Entry.IsOutbound = buf.DecodeBool()
	m.Entry.SaID = buf.DecodeUint32()
	m.Entry.Policy = ipsec_types.IpsecSpdAction(buf.DecodeUint32())
	m.Entry.Protocol = buf.DecodeUint8()
	m.Entry.RemoteAddressStart.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.RemoteAddressStart.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.RemoteAddressStop.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.RemoteAddressStop.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.LocalAddressStart.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.LocalAddressStart.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.LocalAddressStop.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.LocalAddressStop.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.RemotePortStart = buf.DecodeUint16()
	m.Entry.RemotePortStop = buf.DecodeUint16()
	m.Entry.LocalPortStart = buf.DecodeUint16()
	m.Entry.LocalPortStop = buf.DecodeUint16()
	return nil
}

// Dump ipsec policy database data
//   - spd_id - SPD instance id
//   - sa_id - SA id, optional, set to ~0 to see all policies in SPD
//
// IpsecSpdDump defines message 'ipsec_spd_dump'.
type IpsecSpdDump struct {
	SpdID uint32 `binapi:"u32,name=spd_id" json:"spd_id,omitempty"`
	SaID  uint32 `binapi:"u32,name=sa_id" json:"sa_id,omitempty"`
}

func (m *IpsecSpdDump) Reset()               { *m = IpsecSpdDump{} }
func (*IpsecSpdDump) GetMessageName() string { return "ipsec_spd_dump" }
func (*IpsecSpdDump) GetCrcString() string   { return "afefbf7d" }
func (*IpsecSpdDump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSpdDump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SpdID
	size += 4 // m.SaID
	return size
}
func (m *IpsecSpdDump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SpdID)
	buf.EncodeUint32(m.SaID)
	return buf.Bytes(), nil
}
func (m *IpsecSpdDump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SpdID = buf.DecodeUint32()
	m.SaID = buf.DecodeUint32()
	return nil
}

// IPsec: Add/delete Security Policy Database entry
//   - is_add - add SPD if non-zero, else delete
//   - entry - Description of the entry to add/dell
//
// IpsecSpdEntryAddDel defines message 'ipsec_spd_entry_add_del'.
// Deprecated: the message will be removed in the future versions
type IpsecSpdEntryAddDel struct {
	IsAdd bool                      `binapi:"bool,name=is_add" json:"is_add,omitempty"`
	Entry ipsec_types.IpsecSpdEntry `binapi:"ipsec_spd_entry,name=entry" json:"entry,omitempty"`
}

func (m *IpsecSpdEntryAddDel) Reset()               { *m = IpsecSpdEntryAddDel{} }
func (*IpsecSpdEntryAddDel) GetMessageName() string { return "ipsec_spd_entry_add_del" }
func (*IpsecSpdEntryAddDel) GetCrcString() string   { return "338b7411" }
func (*IpsecSpdEntryAddDel) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSpdEntryAddDel) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 1      // m.IsAdd
	size += 4      // m.Entry.SpdID
	size += 4      // m.Entry.Priority
	size += 1      // m.Entry.IsOutbound
	size += 4      // m.Entry.SaID
	size += 4      // m.Entry.Policy
	size += 1      // m.Entry.Protocol
	size += 1      // m.Entry.RemoteAddressStart.Af
	size += 1 * 16 // m.Entry.RemoteAddressStart.Un
	size += 1      // m.Entry.RemoteAddressStop.Af
	size += 1 * 16 // m.Entry.RemoteAddressStop.Un
	size += 1      // m.Entry.LocalAddressStart.Af
	size += 1 * 16 // m.Entry.LocalAddressStart.Un
	size += 1      // m.Entry.LocalAddressStop.Af
	size += 1 * 16 // m.Entry.LocalAddressStop.Un
	size += 2      // m.Entry.RemotePortStart
	size += 2      // m.Entry.RemotePortStop
	size += 2      // m.Entry.LocalPortStart
	size += 2      // m.Entry.LocalPortStop
	return size
}
func (m *IpsecSpdEntryAddDel) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeBool(m.IsAdd)
	buf.EncodeUint32(m.Entry.SpdID)
	buf.EncodeInt32(m.Entry.Priority)
	buf.EncodeBool(m.Entry.IsOutbound)
	buf.EncodeUint32(m.Entry.SaID)
	buf.EncodeUint32(uint32(m.Entry.Policy))
	buf.EncodeUint8(m.Entry.Protocol)
	buf.EncodeUint8(uint8(m.Entry.RemoteAddressStart.Af))
	buf.EncodeBytes(m.Entry.RemoteAddressStart.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.RemoteAddressStop.Af))
	buf.EncodeBytes(m.Entry.RemoteAddressStop.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.LocalAddressStart.Af))
	buf.EncodeBytes(m.Entry.LocalAddressStart.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.LocalAddressStop.Af))
	buf.EncodeBytes(m.Entry.LocalAddressStop.Un.XXX_UnionData[:], 16)
	buf.EncodeUint16(m.Entry.RemotePortStart)
	buf.EncodeUint16(m.Entry.RemotePortStop)
	buf.EncodeUint16(m.Entry.LocalPortStart)
	buf.EncodeUint16(m.Entry.LocalPortStop)
	return buf.Bytes(), nil
}
func (m *IpsecSpdEntryAddDel) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.IsAdd = buf.DecodeBool()
	m.Entry.SpdID = buf.DecodeUint32()
	m.Entry.Priority = buf.DecodeInt32()
	m.Entry.IsOutbound = buf.DecodeBool()
	m.Entry.SaID = buf.DecodeUint32()
	m.Entry.Policy = ipsec_types.IpsecSpdAction(buf.DecodeUint32())
	m.Entry.Protocol = buf.DecodeUint8()
	m.Entry.RemoteAddressStart.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.RemoteAddressStart.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.RemoteAddressStop.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.RemoteAddressStop.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.LocalAddressStart.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.LocalAddressStart.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.LocalAddressStop.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.LocalAddressStop.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.RemotePortStart = buf.DecodeUint16()
	m.Entry.RemotePortStop = buf.DecodeUint16()
	m.Entry.LocalPortStart = buf.DecodeUint16()
	m.Entry.LocalPortStop = buf.DecodeUint16()
	return nil
}

// IPsec: Reply Add/delete Security Policy Database entry
//   - retval - success/fail rutrun code
//   - stat_index - An index for the policy in the stats segment @ /net/ipec/policy
//
// IpsecSpdEntryAddDelReply defines message 'ipsec_spd_entry_add_del_reply'.
// Deprecated: the message will be removed in the future versions
type IpsecSpdEntryAddDelReply struct {
	Retval    int32  `binapi:"i32,name=retval" json:"retval,omitempty"`
	StatIndex uint32 `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSpdEntryAddDelReply) Reset()               { *m = IpsecSpdEntryAddDelReply{} }
func (*IpsecSpdEntryAddDelReply) GetMessageName() string { return "ipsec_spd_entry_add_del_reply" }
func (*IpsecSpdEntryAddDelReply) GetCrcString() string   { return "9ffac24b" }
func (*IpsecSpdEntryAddDelReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSpdEntryAddDelReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	size += 4 // m.StatIndex
	return size
}
func (m *IpsecSpdEntryAddDelReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSpdEntryAddDelReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IPsec: Add/delete Security Policy Database entry v2
//   - is_add - add SPD if non-zero, else delete
//   - entry - Description of the entry to add/dell
//
// IpsecSpdEntryAddDelV2 defines message 'ipsec_spd_entry_add_del_v2'.
type IpsecSpdEntryAddDelV2 struct {
	IsAdd bool                        `binapi:"bool,name=is_add" json:"is_add,omitempty"`
	Entry ipsec_types.IpsecSpdEntryV2 `binapi:"ipsec_spd_entry_v2,name=entry" json:"entry,omitempty"`
}

func (m *IpsecSpdEntryAddDelV2) Reset()               { *m = IpsecSpdEntryAddDelV2{} }
func (*IpsecSpdEntryAddDelV2) GetMessageName() string { return "ipsec_spd_entry_add_del_v2" }
func (*IpsecSpdEntryAddDelV2) GetCrcString() string   { return "7bfe69fc" }
func (*IpsecSpdEntryAddDelV2) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSpdEntryAddDelV2) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 1      // m.IsAdd
	size += 4      // m.Entry.SpdID
	size += 4      // m.Entry.Priority
	size += 1      // m.Entry.IsOutbound
	size += 4      // m.Entry.SaID
	size += 4      // m.Entry.Policy
	size += 1      // m.Entry.Protocol
	size += 1      // m.Entry.RemoteAddressStart.Af
	size += 1 * 16 // m.Entry.RemoteAddressStart.Un
	size += 1      // m.Entry.RemoteAddressStop.Af
	size += 1 * 16 // m.Entry.RemoteAddressStop.Un
	size += 1      // m.Entry.LocalAddressStart.Af
	size += 1 * 16 // m.Entry.LocalAddressStart.Un
	size += 1      // m.Entry.LocalAddressStop.Af
	size += 1 * 16 // m.Entry.LocalAddressStop.Un
	size += 2      // m.Entry.RemotePortStart
	size += 2      // m.Entry.RemotePortStop
	size += 2      // m.Entry.LocalPortStart
	size += 2      // m.Entry.LocalPortStop
	return size
}
func (m *IpsecSpdEntryAddDelV2) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeBool(m.IsAdd)
	buf.EncodeUint32(m.Entry.SpdID)
	buf.EncodeInt32(m.Entry.Priority)
	buf.EncodeBool(m.Entry.IsOutbound)
	buf.EncodeUint32(m.Entry.SaID)
	buf.EncodeUint32(uint32(m.Entry.Policy))
	buf.EncodeUint8(m.Entry.Protocol)
	buf.EncodeUint8(uint8(m.Entry.RemoteAddressStart.Af))
	buf.EncodeBytes(m.Entry.RemoteAddressStart.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.RemoteAddressStop.Af))
	buf.EncodeBytes(m.Entry.RemoteAddressStop.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.LocalAddressStart.Af))
	buf.EncodeBytes(m.Entry.LocalAddressStart.Un.XXX_UnionData[:], 16)
	buf.EncodeUint8(uint8(m.Entry.LocalAddressStop.Af))
	buf.EncodeBytes(m.Entry.LocalAddressStop.Un.XXX_UnionData[:], 16)
	buf.EncodeUint16(m.Entry.RemotePortStart)
	buf.EncodeUint16(m.Entry.RemotePortStop)
	buf.EncodeUint16(m.Entry.LocalPortStart)
	buf.EncodeUint16(m.Entry.LocalPortStop)
	return buf.Bytes(), nil
}
func (m *IpsecSpdEntryAddDelV2) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.IsAdd = buf.DecodeBool()
	m.Entry.SpdID = buf.DecodeUint32()
	m.Entry.Priority = buf.DecodeInt32()
	m.Entry.IsOutbound = buf.DecodeBool()
	m.Entry.SaID = buf.DecodeUint32()
	m.Entry.Policy = ipsec_types.IpsecSpdAction(buf.DecodeUint32())
	m.Entry.Protocol = buf.DecodeUint8()
	m.Entry.RemoteAddressStart.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.RemoteAddressStart.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.RemoteAddressStop.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.RemoteAddressStop.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.LocalAddressStart.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.LocalAddressStart.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.LocalAddressStop.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Entry.LocalAddressStop.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Entry.RemotePortStart = buf.DecodeUint16()
	m.Entry.RemotePortStop = buf.DecodeUint16()
	m.Entry.LocalPortStart = buf.DecodeUint16()
	m.Entry.LocalPortStop = buf.DecodeUint16()
	return nil
}

// IPsec: Reply Add/delete Security Policy Database entry v2
//   - retval - success/fail rutrun code
//   - stat_index - An index for the policy in the stats segment @ /net/ipec/policy
//
// IpsecSpdEntryAddDelV2Reply defines message 'ipsec_spd_entry_add_del_v2_reply'.
type IpsecSpdEntryAddDelV2Reply struct {
	Retval    int32  `binapi:"i32,name=retval" json:"retval,omitempty"`
	StatIndex uint32 `binapi:"u32,name=stat_index" json:"stat_index,omitempty"`
}

func (m *IpsecSpdEntryAddDelV2Reply) Reset()               { *m = IpsecSpdEntryAddDelV2Reply{} }
func (*IpsecSpdEntryAddDelV2Reply) GetMessageName() string { return "ipsec_spd_entry_add_del_v2_reply" }
func (*IpsecSpdEntryAddDelV2Reply) GetCrcString() string   { return "9ffac24b" }
func (*IpsecSpdEntryAddDelV2Reply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSpdEntryAddDelV2Reply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	size += 4 // m.StatIndex
	return size
}
func (m *IpsecSpdEntryAddDelV2Reply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	buf.EncodeUint32(m.StatIndex)
	return buf.Bytes(), nil
}
func (m *IpsecSpdEntryAddDelV2Reply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	m.StatIndex = buf.DecodeUint32()
	return nil
}

// IPsec: SPD interface response
//   - spd_index - SPD index
//   - sw_if_index - index of the interface
//
// IpsecSpdInterfaceDetails defines message 'ipsec_spd_interface_details'.
type IpsecSpdInterfaceDetails struct {
	SpdIndex  uint32                         `binapi:"u32,name=spd_index" json:"spd_index,omitempty"`
	SwIfIndex interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
}

func (m *IpsecSpdInterfaceDetails) Reset()               { *m = IpsecSpdInterfaceDetails{} }
func (*IpsecSpdInterfaceDetails) GetMessageName() string { return "ipsec_spd_interface_details" }
func (*IpsecSpdInterfaceDetails) GetCrcString() string   { return "7a0bcf3e" }
func (*IpsecSpdInterfaceDetails) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSpdInterfaceDetails) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SpdIndex
	size += 4 // m.SwIfIndex
	return size
}
func (m *IpsecSpdInterfaceDetails) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SpdIndex)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	return buf.Bytes(), nil
}
func (m *IpsecSpdInterfaceDetails) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SpdIndex = buf.DecodeUint32()
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	return nil
}

// IPsec: Get SPD interfaces
//   - spd_index - SPD index
//   - spd_index_valid - if 1 spd_index is used to filter
//     spd_index's, if 0 no filtering is done
//
// IpsecSpdInterfaceDump defines message 'ipsec_spd_interface_dump'.
type IpsecSpdInterfaceDump struct {
	SpdIndex      uint32 `binapi:"u32,name=spd_index" json:"spd_index,omitempty"`
	SpdIndexValid uint8  `binapi:"u8,name=spd_index_valid" json:"spd_index_valid,omitempty"`
}

func (m *IpsecSpdInterfaceDump) Reset()               { *m = IpsecSpdInterfaceDump{} }
func (*IpsecSpdInterfaceDump) GetMessageName() string { return "ipsec_spd_interface_dump" }
func (*IpsecSpdInterfaceDump) GetCrcString() string   { return "8971de19" }
func (*IpsecSpdInterfaceDump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSpdInterfaceDump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SpdIndex
	size += 1 // m.SpdIndexValid
	return size
}
func (m *IpsecSpdInterfaceDump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SpdIndex)
	buf.EncodeUint8(m.SpdIndexValid)
	return buf.Bytes(), nil
}
func (m *IpsecSpdInterfaceDump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SpdIndex = buf.DecodeUint32()
	m.SpdIndexValid = buf.DecodeUint8()
	return nil
}

// Dump IPsec all SPD IDs response
//   - spd_id - SPD instance id (control plane allocated)
//   - npolicies - number of policies in SPD
//
// IpsecSpdsDetails defines message 'ipsec_spds_details'.
type IpsecSpdsDetails struct {
	SpdID     uint32 `binapi:"u32,name=spd_id" json:"spd_id,omitempty"`
	Npolicies uint32 `binapi:"u32,name=npolicies" json:"npolicies,omitempty"`
}

func (m *IpsecSpdsDetails) Reset()               { *m = IpsecSpdsDetails{} }
func (*IpsecSpdsDetails) GetMessageName() string { return "ipsec_spds_details" }
func (*IpsecSpdsDetails) GetCrcString() string   { return "a04bb254" }
func (*IpsecSpdsDetails) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecSpdsDetails) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SpdID
	size += 4 // m.Npolicies
	return size
}
func (m *IpsecSpdsDetails) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(m.SpdID)
	buf.EncodeUint32(m.Npolicies)
	return buf.Bytes(), nil
}
func (m *IpsecSpdsDetails) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SpdID = buf.DecodeUint32()
	m.Npolicies = buf.DecodeUint32()
	return nil
}

// Dump IPsec all SPD IDs
// IpsecSpdsDump defines message 'ipsec_spds_dump'.
type IpsecSpdsDump struct{}

func (m *IpsecSpdsDump) Reset()               { *m = IpsecSpdsDump{} }
func (*IpsecSpdsDump) GetMessageName() string { return "ipsec_spds_dump" }
func (*IpsecSpdsDump) GetCrcString() string   { return "51077d14" }
func (*IpsecSpdsDump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecSpdsDump) Size() (size int) {
	if m == nil {
		return 0
	}
	return size
}
func (m *IpsecSpdsDump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	return buf.Bytes(), nil
}
func (m *IpsecSpdsDump) Unmarshal(b []byte) error {
	return nil
}

// IpsecTunnelProtectDel defines message 'ipsec_tunnel_protect_del'.
type IpsecTunnelProtectDel struct {
	SwIfIndex interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
	Nh        ip_types.Address               `binapi:"address,name=nh" json:"nh,omitempty"`
}

func (m *IpsecTunnelProtectDel) Reset()               { *m = IpsecTunnelProtectDel{} }
func (*IpsecTunnelProtectDel) GetMessageName() string { return "ipsec_tunnel_protect_del" }
func (*IpsecTunnelProtectDel) GetCrcString() string   { return "cd239930" }
func (*IpsecTunnelProtectDel) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecTunnelProtectDel) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4      // m.SwIfIndex
	size += 1      // m.Nh.Af
	size += 1 * 16 // m.Nh.Un
	return size
}
func (m *IpsecTunnelProtectDel) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	buf.EncodeUint8(uint8(m.Nh.Af))
	buf.EncodeBytes(m.Nh.Un.XXX_UnionData[:], 16)
	return buf.Bytes(), nil
}
func (m *IpsecTunnelProtectDel) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Nh.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Nh.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	return nil
}

// IpsecTunnelProtectDelReply defines message 'ipsec_tunnel_protect_del_reply'.
type IpsecTunnelProtectDelReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecTunnelProtectDelReply) Reset()               { *m = IpsecTunnelProtectDelReply{} }
func (*IpsecTunnelProtectDelReply) GetMessageName() string { return "ipsec_tunnel_protect_del_reply" }
func (*IpsecTunnelProtectDelReply) GetCrcString() string   { return "e8d4e804" }
func (*IpsecTunnelProtectDelReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecTunnelProtectDelReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecTunnelProtectDelReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecTunnelProtectDelReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

// IpsecTunnelProtectDetails defines message 'ipsec_tunnel_protect_details'.
type IpsecTunnelProtectDetails struct {
	Tun IpsecTunnelProtect `binapi:"ipsec_tunnel_protect,name=tun" json:"tun,omitempty"`
}

func (m *IpsecTunnelProtectDetails) Reset()               { *m = IpsecTunnelProtectDetails{} }
func (*IpsecTunnelProtectDetails) GetMessageName() string { return "ipsec_tunnel_protect_details" }
func (*IpsecTunnelProtectDetails) GetCrcString() string   { return "21663a50" }
func (*IpsecTunnelProtectDetails) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecTunnelProtectDetails) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4                   // m.Tun.SwIfIndex
	size += 1                   // m.Tun.Nh.Af
	size += 1 * 16              // m.Tun.Nh.Un
	size += 4                   // m.Tun.SaOut
	size += 1                   // m.Tun.NSaIn
	size += 4 * len(m.Tun.SaIn) // m.Tun.SaIn
	return size
}
func (m *IpsecTunnelProtectDetails) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(uint32(m.Tun.SwIfIndex))
	buf.EncodeUint8(uint8(m.Tun.Nh.Af))
	buf.EncodeBytes(m.Tun.Nh.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(m.Tun.SaOut)
	buf.EncodeUint8(uint8(len(m.Tun.SaIn)))
	for i := 0; i < len(m.Tun.SaIn); i++ {
		var x uint32
		if i < len(m.Tun.SaIn) {
			x = uint32(m.Tun.SaIn[i])
		}
		buf.EncodeUint32(x)
	}
	return buf.Bytes(), nil
}
func (m *IpsecTunnelProtectDetails) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Tun.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Tun.Nh.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Tun.Nh.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Tun.SaOut = buf.DecodeUint32()
	m.Tun.NSaIn = buf.DecodeUint8()
	m.Tun.SaIn = make([]uint32, m.Tun.NSaIn)
	for i := 0; i < len(m.Tun.SaIn); i++ {
		m.Tun.SaIn[i] = buf.DecodeUint32()
	}
	return nil
}

// * @brief Dump all tunnel protections
// IpsecTunnelProtectDump defines message 'ipsec_tunnel_protect_dump'.
type IpsecTunnelProtectDump struct {
	SwIfIndex interface_types.InterfaceIndex `binapi:"interface_index,name=sw_if_index" json:"sw_if_index,omitempty"`
}

func (m *IpsecTunnelProtectDump) Reset()               { *m = IpsecTunnelProtectDump{} }
func (*IpsecTunnelProtectDump) GetMessageName() string { return "ipsec_tunnel_protect_dump" }
func (*IpsecTunnelProtectDump) GetCrcString() string   { return "f9e6675e" }
func (*IpsecTunnelProtectDump) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecTunnelProtectDump) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.SwIfIndex
	return size
}
func (m *IpsecTunnelProtectDump) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(uint32(m.SwIfIndex))
	return buf.Bytes(), nil
}
func (m *IpsecTunnelProtectDump) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	return nil
}

// Add or Update Protection for a tunnel with IPSEC
//
//	Tunnel protection directly associates an SA with all packets
//	ingress and egress on the tunnel. This could also be achieved by
//	assigning an SPD to the tunnel, but that would incur an unnessccary
//	SPD entry lookup.
//	For tunnels the ESP acts on the post-encapsulated packet. So if this
//	packet:
//	  +---------+------+
//	  | Payload | O-IP |
//	  +---------+------+
//	where O-IP is the overlay IP addrees that was routed into the tunnel,
//	the resulting encapsulated packet will be:
//	  +---------+------+------+
//	  | Payload | O-IP | T-IP |
//	  +---------+------+------+
//	where T-IP is the tunnel's src.dst IP addresses.
//	If the SAs used for protection are in transport mode then the ESP is
//	inserted before T-IP, i.e.:
//	  +---------+------+-----+------+
//	  | Payload | O-IP | ESP | T-IP |
//	  +---------+------+-----+------+
//	If the SAs used for protection are in tunnel mode then another
//	encapsulation occurs, i.e.:
//	  +---------+------+------+-----+------+
//	  | Payload | O-IP | T-IP | ESP | C-IP |
//	  +---------+------+------+-----+------+
//	where C-IP are the crypto endpoint IP addresses defined as the tunnel
//	endpoints in the SA.
//	The mode for the inbound and outbound SA must be the same.
//	- sw_id_index - Tunnel interface to protect
//	- nh - The peer/next-hop on the tunnel to which the traffic
//	            should be protected. For a P2P interface set this to the
//	            all 0s address.
//	- sa_in - The ID [set] of inbound SAs
//	- sa_out - The ID of outbound SA
//
// IpsecTunnelProtectUpdate defines message 'ipsec_tunnel_protect_update'.
type IpsecTunnelProtectUpdate struct {
	Tunnel IpsecTunnelProtect `binapi:"ipsec_tunnel_protect,name=tunnel" json:"tunnel,omitempty"`
}

func (m *IpsecTunnelProtectUpdate) Reset()               { *m = IpsecTunnelProtectUpdate{} }
func (*IpsecTunnelProtectUpdate) GetMessageName() string { return "ipsec_tunnel_protect_update" }
func (*IpsecTunnelProtectUpdate) GetCrcString() string   { return "30d5f133" }
func (*IpsecTunnelProtectUpdate) GetMessageType() api.MessageType {
	return api.RequestMessage
}

func (m *IpsecTunnelProtectUpdate) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4                      // m.Tunnel.SwIfIndex
	size += 1                      // m.Tunnel.Nh.Af
	size += 1 * 16                 // m.Tunnel.Nh.Un
	size += 4                      // m.Tunnel.SaOut
	size += 1                      // m.Tunnel.NSaIn
	size += 4 * len(m.Tunnel.SaIn) // m.Tunnel.SaIn
	return size
}
func (m *IpsecTunnelProtectUpdate) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeUint32(uint32(m.Tunnel.SwIfIndex))
	buf.EncodeUint8(uint8(m.Tunnel.Nh.Af))
	buf.EncodeBytes(m.Tunnel.Nh.Un.XXX_UnionData[:], 16)
	buf.EncodeUint32(m.Tunnel.SaOut)
	buf.EncodeUint8(uint8(len(m.Tunnel.SaIn)))
	for i := 0; i < len(m.Tunnel.SaIn); i++ {
		var x uint32
		if i < len(m.Tunnel.SaIn) {
			x = uint32(m.Tunnel.SaIn[i])
		}
		buf.EncodeUint32(x)
	}
	return buf.Bytes(), nil
}
func (m *IpsecTunnelProtectUpdate) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Tunnel.SwIfIndex = interface_types.InterfaceIndex(buf.DecodeUint32())
	m.Tunnel.Nh.Af = ip_types.AddressFamily(buf.DecodeUint8())
	copy(m.Tunnel.Nh.Un.XXX_UnionData[:], buf.DecodeBytes(16))
	m.Tunnel.SaOut = buf.DecodeUint32()
	m.Tunnel.NSaIn = buf.DecodeUint8()
	m.Tunnel.SaIn = make([]uint32, m.Tunnel.NSaIn)
	for i := 0; i < len(m.Tunnel.SaIn); i++ {
		m.Tunnel.SaIn[i] = buf.DecodeUint32()
	}
	return nil
}

// IpsecTunnelProtectUpdateReply defines message 'ipsec_tunnel_protect_update_reply'.
type IpsecTunnelProtectUpdateReply struct {
	Retval int32 `binapi:"i32,name=retval" json:"retval,omitempty"`
}

func (m *IpsecTunnelProtectUpdateReply) Reset() { *m = IpsecTunnelProtectUpdateReply{} }
func (*IpsecTunnelProtectUpdateReply) GetMessageName() string {
	return "ipsec_tunnel_protect_update_reply"
}
func (*IpsecTunnelProtectUpdateReply) GetCrcString() string { return "e8d4e804" }
func (*IpsecTunnelProtectUpdateReply) GetMessageType() api.MessageType {
	return api.ReplyMessage
}

func (m *IpsecTunnelProtectUpdateReply) Size() (size int) {
	if m == nil {
		return 0
	}
	size += 4 // m.Retval
	return size
}
func (m *IpsecTunnelProtectUpdateReply) Marshal(b []byte) ([]byte, error) {
	if b == nil {
		b = make([]byte, m.Size())
	}
	buf := codec.NewBuffer(b)
	buf.EncodeInt32(m.Retval)
	return buf.Bytes(), nil
}
func (m *IpsecTunnelProtectUpdateReply) Unmarshal(b []byte) error {
	buf := codec.NewBuffer(b)
	m.Retval = buf.DecodeInt32()
	return nil
}

func init() { file_ipsec_binapi_init() }
func file_ipsec_binapi_init() {
	api.RegisterMessage((*IpsecBackendDetails)(nil), "ipsec_backend_details_ee601c29")
	api.RegisterMessage((*IpsecBackendDump)(nil), "ipsec_backend_dump_51077d14")
	api.RegisterMessage((*IpsecInterfaceAddDelSpd)(nil), "ipsec_interface_add_del_spd_80f80cbb")
	api.RegisterMessage((*IpsecInterfaceAddDelSpdReply)(nil), "ipsec_interface_add_del_spd_reply_e8d4e804")
	api.RegisterMessage((*IpsecItfCreate)(nil), "ipsec_itf_create_6f50b3bc")
	api.RegisterMessage((*IpsecItfCreateReply)(nil), "ipsec_itf_create_reply_5383d31f")
	api.RegisterMessage((*IpsecItfDelete)(nil), "ipsec_itf_delete_f9e6675e")
	api.RegisterMessage((*IpsecItfDeleteReply)(nil), "ipsec_itf_delete_reply_e8d4e804")
	api.RegisterMessage((*IpsecItfDetails)(nil), "ipsec_itf_details_548a73b8")
	api.RegisterMessage((*IpsecItfDump)(nil), "ipsec_itf_dump_f9e6675e")
	api.RegisterMessage((*IpsecSaDetails)(nil), "ipsec_sa_details_345d14a7")
	api.RegisterMessage((*IpsecSaDump)(nil), "ipsec_sa_dump_2076c2f4")
	api.RegisterMessage((*IpsecSaV2Details)(nil), "ipsec_sa_v2_details_e2130051")
	api.RegisterMessage((*IpsecSaV2Dump)(nil), "ipsec_sa_v2_dump_2076c2f4")
	api.RegisterMessage((*IpsecSaV3Details)(nil), "ipsec_sa_v3_details_2fc991ee")
	api.RegisterMessage((*IpsecSaV3Dump)(nil), "ipsec_sa_v3_dump_2076c2f4")
	api.RegisterMessage((*IpsecSaV4Details)(nil), "ipsec_sa_v4_details_87a322d7")
	api.RegisterMessage((*IpsecSaV4Dump)(nil), "ipsec_sa_v4_dump_2076c2f4")
	api.RegisterMessage((*IpsecSaV5Details)(nil), "ipsec_sa_v5_details_3cfecfbd")
	api.RegisterMessage((*IpsecSaV5Dump)(nil), "ipsec_sa_v5_dump_2076c2f4")
	api.RegisterMessage((*IpsecSadBind)(nil), "ipsec_sad_bind_0649c0d9")
	api.RegisterMessage((*IpsecSadBindReply)(nil), "ipsec_sad_bind_reply_e8d4e804")
	api.RegisterMessage((*IpsecSadEntryAdd)(nil), "ipsec_sad_entry_add_50229353")
	api.RegisterMessage((*IpsecSadEntryAddDel)(nil), "ipsec_sad_entry_add_del_ab64b5c6")
	api.RegisterMessage((*IpsecSadEntryAddDelReply)(nil), "ipsec_sad_entry_add_del_reply_9ffac24b")
	api.RegisterMessage((*IpsecSadEntryAddDelV2)(nil), "ipsec_sad_entry_add_del_v2_aca78b27")
	api.RegisterMessage((*IpsecSadEntryAddDelV2Reply)(nil), "ipsec_sad_entry_add_del_v2_reply_9ffac24b")
	api.RegisterMessage((*IpsecSadEntryAddDelV3)(nil), "ipsec_sad_entry_add_del_v3_c77ebd92")
	api.RegisterMessage((*IpsecSadEntryAddDelV3Reply)(nil), "ipsec_sad_entry_add_del_v3_reply_9ffac24b")
	api.RegisterMessage((*IpsecSadEntryAddReply)(nil), "ipsec_sad_entry_add_reply_9ffac24b")
	api.RegisterMessage((*IpsecSadEntryAddV2)(nil), "ipsec_sad_entry_add_v2_9611297a")
	api.RegisterMessage((*IpsecSadEntryAddV2Reply)(nil), "ipsec_sad_entry_add_v2_reply_9ffac24b")
	api.RegisterMessage((*IpsecSadEntryDel)(nil), "ipsec_sad_entry_del_3a91bde5")
	api.RegisterMessage((*IpsecSadEntryDelReply)(nil), "ipsec_sad_entry_del_reply_e8d4e804")
	api.RegisterMessage((*IpsecSadEntryUpdate)(nil), "ipsec_sad_entry_update_1412af86")
	api.RegisterMessage((*IpsecSadEntryUpdateReply)(nil), "ipsec_sad_entry_update_reply_e8d4e804")
	api.RegisterMessage((*IpsecSadUnbind)(nil), "ipsec_sad_unbind_2076c2f4")
	api.RegisterMessage((*IpsecSadUnbindReply)(nil), "ipsec_sad_unbind_reply_e8d4e804")
	api.RegisterMessage((*IpsecSelectBackend)(nil), "ipsec_select_backend_5bcfd3b7")
	api.RegisterMessage((*IpsecSelectBackendReply)(nil), "ipsec_select_backend_reply_e8d4e804")
	api.RegisterMessage((*IpsecSetAsyncMode)(nil), "ipsec_set_async_mode_a6465f7c")
	api.RegisterMessage((*IpsecSetAsyncModeReply)(nil), "ipsec_set_async_mode_reply_e8d4e804")
	api.RegisterMessage((*IpsecSpdAddDel)(nil), "ipsec_spd_add_del_20e89a95")
	api.RegisterMessage((*IpsecSpdAddDelReply)(nil), "ipsec_spd_add_del_reply_e8d4e804")
	api.RegisterMessage((*IpsecSpdDetails)(nil), "ipsec_spd_details_5813d7a2")
	api.RegisterMessage((*IpsecSpdDump)(nil), "ipsec_spd_dump_afefbf7d")
	api.RegisterMessage((*IpsecSpdEntryAddDel)(nil), "ipsec_spd_entry_add_del_338b7411")
	api.RegisterMessage((*IpsecSpdEntryAddDelReply)(nil), "ipsec_spd_entry_add_del_reply_9ffac24b")
	api.RegisterMessage((*IpsecSpdEntryAddDelV2)(nil), "ipsec_spd_entry_add_del_v2_7bfe69fc")
	api.RegisterMessage((*IpsecSpdEntryAddDelV2Reply)(nil), "ipsec_spd_entry_add_del_v2_reply_9ffac24b")
	api.RegisterMessage((*IpsecSpdInterfaceDetails)(nil), "ipsec_spd_interface_details_7a0bcf3e")
	api.RegisterMessage((*IpsecSpdInterfaceDump)(nil), "ipsec_spd_interface_dump_8971de19")
	api.RegisterMessage((*IpsecSpdsDetails)(nil), "ipsec_spds_details_a04bb254")
	api.RegisterMessage((*IpsecSpdsDump)(nil), "ipsec_spds_dump_51077d14")
	api.RegisterMessage((*IpsecTunnelProtectDel)(nil), "ipsec_tunnel_protect_del_cd239930")
	api.RegisterMessage((*IpsecTunnelProtectDelReply)(nil), "ipsec_tunnel_protect_del_reply_e8d4e804")
	api.RegisterMessage((*IpsecTunnelProtectDetails)(nil), "ipsec_tunnel_protect_details_21663a50")
	api.RegisterMessage((*IpsecTunnelProtectDump)(nil), "ipsec_tunnel_protect_dump_f9e6675e")
	api.RegisterMessage((*IpsecTunnelProtectUpdate)(nil), "ipsec_tunnel_protect_update_30d5f133")
	api.RegisterMessage((*IpsecTunnelProtectUpdateReply)(nil), "ipsec_tunnel_protect_update_reply_e8d4e804")
}

// Messages returns list of all messages in this module.
func AllMessages() []api.Message {
	return []api.Message{
		(*IpsecBackendDetails)(nil),
		(*IpsecBackendDump)(nil),
		(*IpsecInterfaceAddDelSpd)(nil),
		(*IpsecInterfaceAddDelSpdReply)(nil),
		(*IpsecItfCreate)(nil),
		(*IpsecItfCreateReply)(nil),
		(*IpsecItfDelete)(nil),
		(*IpsecItfDeleteReply)(nil),
		(*IpsecItfDetails)(nil),
		(*IpsecItfDump)(nil),
		(*IpsecSaDetails)(nil),
		(*IpsecSaDump)(nil),
		(*IpsecSaV2Details)(nil),
		(*IpsecSaV2Dump)(nil),
		(*IpsecSaV3Details)(nil),
		(*IpsecSaV3Dump)(nil),
		(*IpsecSaV4Details)(nil),
		(*IpsecSaV4Dump)(nil),
		(*IpsecSaV5Details)(nil),
		(*IpsecSaV5Dump)(nil),
		(*IpsecSadBind)(nil),
		(*IpsecSadBindReply)(nil),
		(*IpsecSadEntryAdd)(nil),
		(*IpsecSadEntryAddDel)(nil),
		(*IpsecSadEntryAddDelReply)(nil),
		(*IpsecSadEntryAddDelV2)(nil),
		(*IpsecSadEntryAddDelV2Reply)(nil),
		(*IpsecSadEntryAddDelV3)(nil),
		(*IpsecSadEntryAddDelV3Reply)(nil),
		(*IpsecSadEntryAddReply)(nil),
		(*IpsecSadEntryAddV2)(nil),
		(*IpsecSadEntryAddV2Reply)(nil),
		(*IpsecSadEntryDel)(nil),
		(*IpsecSadEntryDelReply)(nil),
		(*IpsecSadEntryUpdate)(nil),
		(*IpsecSadEntryUpdateReply)(nil),
		(*IpsecSadUnbind)(nil),
		(*IpsecSadUnbindReply)(nil),
		(*IpsecSelectBackend)(nil),
		(*IpsecSelectBackendReply)(nil),
		(*IpsecSetAsyncMode)(nil),
		(*IpsecSetAsyncModeReply)(nil),
		(*IpsecSpdAddDel)(nil),
		(*IpsecSpdAddDelReply)(nil),
		(*IpsecSpdDetails)(nil),
		(*IpsecSpdDump)(nil),
		(*IpsecSpdEntryAddDel)(nil),
		(*IpsecSpdEntryAddDelReply)(nil),
		(*IpsecSpdEntryAddDelV2)(nil),
		(*IpsecSpdEntryAddDelV2Reply)(nil),
		(*IpsecSpdInterfaceDetails)(nil),
		(*IpsecSpdInterfaceDump)(nil),
		(*IpsecSpdsDetails)(nil),
		(*IpsecSpdsDump)(nil),
		(*IpsecTunnelProtectDel)(nil),
		(*IpsecTunnelProtectDelReply)(nil),
		(*IpsecTunnelProtectDetails)(nil),
		(*IpsecTunnelProtectDump)(nil),
		(*IpsecTunnelProtectUpdate)(nil),
		(*IpsecTunnelProtectUpdateReply)(nil),
	}
}
